unit n2_complex;

interface

type tcomplex=record
       re,im:double;
       end;

function setc(re,im:double):tcomplex;
function absc(ci:tcomplex):double;
function argc(ci:tcomplex):double;
function real(ci:tcomplex):double;
function imag(ci:tcomplex):double;
function conj(ci:tcomplex):tcomplex;
function addc(c1,c2:tcomplex):tcomplex;
function addc(s:double;ci:tcomplex):tcomplex;
function addc(ci:tcomplex;s:double):tcomplex;
function subc(c1,c2:tcomplex):tcomplex;
function subc(s:double;ci:tcomplex):tcomplex;
function subc(ci:tcomplex;s:double):tcomplex;
function mulc(c1,c2:tcomplex):tcomplex;
function mulc(s:double;ci:tcomplex):tcomplex;
function mulc(ci:tcomplex;s:double):tcomplex;
function divc(c1,c2:tcomplex):tcomplex;
function divc(ci:tcomplex;s:double):tcomplex;
function invc(ci:tcomplex):tcomplex;
function expc(ci:tcomplex):tcomplex;
function lnc(ci:tcomplex):tcomplex;
function sqrc(ci:tcomplex):tcomplex;
function sqrtc(ci:tcomplex):tcomplex;
function powerc(ci:tcomplex;e:double):tcomplex;
function powerc(cb,ce:tcomplex):tcomplex;
function sinc(ci:tcomplex):tcomplex;
function cosc(ci:tcomplex):tcomplex;
function tanc(ci:tcomplex):tcomplex;
function cotc(ci:tcomplex):tcomplex;
function secc(ci:tcomplex):tcomplex;
function cscc(ci:tcomplex):tcomplex;
function arcsinc(ci:tcomplex):tcomplex;
function arccosc(ci:tcomplex):tcomplex;
function arctanc(ci:tcomplex):tcomplex;
function arccotc(ci:tcomplex):tcomplex;
function arcsecc(ci:tcomplex):tcomplex;
function arccscc(ci:tcomplex):tcomplex;
function sinhc(ci:tcomplex):tcomplex;
function coshc(ci:tcomplex):tcomplex;
function tanhc(ci:tcomplex):tcomplex;
function cothc(ci:tcomplex):tcomplex;
function sechc(ci:tcomplex):tcomplex;
function cschc(ci:tcomplex):tcomplex;
function arsinhc(ci:tcomplex):tcomplex;
function arcoshc(ci:tcomplex):tcomplex;
function artanhc(ci:tcomplex):tcomplex;
function arcothc(ci:tcomplex):tcomplex;
function arsechc(ci:tcomplex):tcomplex;
function arcschc(ci:tcomplex):tcomplex;

implementation

uses n2_mathe;

function setc(re,im:double):tcomplex;
var c:tcomplex;
begin
  c.re:=re;
  c.im:=im;
  setc:=c;
end;

function absc(ci:tcomplex):double;
begin
  absc:=sqrt(sqr(ci.re)+sqr(ci.im));
end;

function argc(ci:tcomplex):double;
begin
  if ci.re<>0 then argc:=arctan(ci.im/ci.re)+pi*byte((ci.re<0) and (ci.im>=0))-pi*byte((ci.re<0) and (ci.im<0))
              else begin if ci.im<>0 then argc:=pi*(byte(ci.im>0)-0.5) else argc:=0; end;
end;

function real(ci:tcomplex):double;
begin
  real:=ci.re;
end;

function imag(ci:tcomplex):double;
begin
  imag:=ci.im;
end;

function conj(ci:tcomplex):tcomplex;
begin
  conj:=setc(ci.re,-ci.im);
end;

function addc(c1,c2:tcomplex):tcomplex;
begin
  addc:=setc(c1.re+c2.re,c1.im+c2.im);
end;

function addc(ci:tcomplex;s:double):tcomplex;
begin
  addc:=setc(ci.re+s,ci.im);
end;

function addc(s:double;ci:tcomplex):tcomplex;
begin
  addc:=setc(s+ci.re,ci.im);
end;

function subc(c1,c2:tcomplex):tcomplex;
begin
  subc:=setc(c1.re-c2.re,c1.im-c2.im);
end;

function subc(ci:tcomplex;s:double):tcomplex;
begin
  subc:=setc(ci.re-s,ci.im);
end;

function subc(s:double;ci:tcomplex):tcomplex;
begin
  subc:=setc(s-ci.re,-ci.im);
end;

function mulc(c1,c2:tcomplex):tcomplex;
begin
  mulc:=setc(c1.re*c2.re-c1.im*c2.im,c1.re*c2.im+c1.im*c2.re);
end;

function mulc(s:double;ci:tcomplex):tcomplex;
begin
  mulc:=setc(s*ci.re,s*ci.im);
end;

function mulc(ci:tcomplex;s:double):tcomplex;
begin
  mulc:=setc(ci.re*s,ci.im*s);
end;

function divc(c1,c2:tcomplex):tcomplex;
begin
  if sqr(c2.re)+sqr(c2.im)>0 then divc:=setc((c1.re*c2.re+c1.im*c2.im)/(sqr(c2.re)+sqr(c2.im)),(c1.im*c2.re-c1.re*c2.im)/(sqr(c2.re)+sqr(c2.im)))
							 else divc:=setc(nan,nan);
end;

function divc(ci:tcomplex;s:double):tcomplex;
begin
  if sqr(s)>0 then divc:=setc(ci.re/s,ci.im/s)
			  else divc:=setc(nan,nan);
end;

function invc(ci:tcomplex):tcomplex;
begin
  invc:=divc(setc(1,0),ci);
end;

function expc(ci:tcomplex):tcomplex;
begin
  expc:=setc(exp(ci.re)*cos(ci.im),exp(ci.re)*sin(ci.im));
end;

function lnc(ci:tcomplex):tcomplex;
begin
  if absc(ci)>0 then lnc:=setc(ln(absc(ci)),argc(ci)) else 
  begin
    lnc.re:=nan;
    lnc.im:=0;
  end;
end;

function sqrc(ci:tcomplex):tcomplex;
begin
  sqrc:=mulc(ci,ci);
end;

function sqrtc(ci:tcomplex):tcomplex;
begin
  sqrtc:=setc(sqrt(absc(ci))*cos(argc(ci)/2),sqrt(absc(ci))*sin(argc(ci)/2));
end;

function powerc(ci:tcomplex;e:double):tcomplex;
begin
  powerc:=setc(power(absc(ci),e)*cos(e*argc(ci)),power(absc(ci),e)*sin(e*argc(ci)));
end;

function powerc(cb,ce:tcomplex):tcomplex;
begin
  powerc:=expc(mulc(ce,lnc(cb)));
end;

function sinc(ci:tcomplex):tcomplex;
begin
  sinc:=setc(sin(ci.re)*cosh(ci.im),cos(ci.re)*sinh(ci.im));
end;

function cosc(ci:tcomplex):tcomplex;
begin
  cosc:=setc(cos(ci.re)*cosh(ci.im),-sin(ci.re)*sinh(ci.im));
end;

function tanc(ci:tcomplex):tcomplex;
begin
  tanc:=divc(sinc(ci),cosc(ci));
end;

function cotc(ci:tcomplex):tcomplex;
begin
  cotc:=divc(cosc(ci),sinc(ci));
end;

function secc(ci:tcomplex):tcomplex;
begin
  secc:=divc(setc(1,0),cosc(ci));
end;

function cscc(ci:tcomplex):tcomplex;
begin
  cscc:=divc(setc(1,0),sinc(ci));
end;

function arcsinc(ci:tcomplex):tcomplex;
begin
  arcsinc:=mulc(setc(0,-1),lnc(addc(mulc(setc(0,1),ci),sqrtc(subc(setc(1,0),sqrc(ci))))));
end;

function arccosc(ci:tcomplex):tcomplex;
begin
  arccosc:=mulc(setc(0,-1),lnc(addc(ci,mulc(setc(0,1),sqrtc(subc(setc(1,0),sqrc(ci)))))));
end;

function arctanc(ci:tcomplex):tcomplex;
begin
  arctanc:=mulc(-0.5,mulc(setc(0,1),lnc(divc(addc(setc(1,0),mulc(setc(0,1),ci)),subc(setc(1,0),mulc(setc(0,1),ci))))));
end;

function arccotc(ci:tcomplex):tcomplex;
begin
  arccotc:=mulc(-0.5,mulc(setc(0,1),lnc(divc(subc(mulc(setc(0,1),ci),setc(1,0)),addc(mulc(setc(0,1),ci),setc(1,0))))));
end;

function arcsecc(ci:tcomplex):tcomplex;
begin
  arcsecc:=arccosc(divc(setc(1,0),ci));
end;

function arccscc(ci:tcomplex):tcomplex;
begin
  arccscc:=arcsinc(divc(setc(1,0),ci));
end;

function sinhc(ci:tcomplex):tcomplex;
begin
  sinhc:=setc(sinh(ci.re)*cos(ci.im),cosh(ci.re)*sin(ci.im));
end;

function coshc(ci:tcomplex):tcomplex;
begin
  coshc:=setc(cosh(ci.re)*cos(ci.im),sinh(ci.re)*sin(ci.im));
end;

function tanhc(ci:tcomplex):tcomplex;
begin
  tanhc:=divc(sinhc(ci),coshc(ci));
end;

function cothc(ci:tcomplex):tcomplex;
begin
  cothc:=divc(coshc(ci),sinhc(ci));
end;

function sechc(ci:tcomplex):tcomplex;
begin
  sechc:=divc(setc(1,0),coshc(ci));
end;

function cschc(ci:tcomplex):tcomplex;
begin
  cschc:=divc(setc(1,0),sinhc(ci));
end;

function arsinhc(ci:tcomplex):tcomplex;
begin
  arsinhc:=lnc(addc(ci,sqrtc(addc(sqrc(ci),setc(1,0)))));
end;

function arcoshc(ci:tcomplex):tcomplex;
begin
  arcoshc:=lnc(addc(ci,sqrtc(subc(sqrc(ci),setc(1,0)))));
end;

function artanhc(ci:tcomplex):tcomplex;
begin
  artanhc:=mulc(0.5,lnc(divc(addc(setc(1,0),ci),subc(setc(1,0),ci))));
end;

function arcothc(ci:tcomplex):tcomplex;
begin
  arcothc:=mulc(0.5,lnc(divc(addc(ci,setc(1,0)),subc(ci,setc(1,0)))));
end;

function arsechc(ci:tcomplex):tcomplex;
begin
  arsechc:=arcoshc(divc(setc(1,0),ci));
end;

function arcschc(ci:tcomplex):tcomplex;
begin
  arcschc:=arsinhc(divc(setc(1,0),ci));
end;

end.
