unit n2_image;

interface

type tcoltype=(rgb,rgba,y,ya);
     timgtype=(tru,idx);
     timage=record
       sx,sy:longint;
	   imgtype:timgtype;
	   coltype:tcoltype;
       img:record
	     y:array of array of word;
	     r:array of array of word;
	     g:array of array of word;
	     b:array of array of word;
	     a:array of array of word;
	     i:array of array of word;
		 end;
	   pal:record
	     y:array of word;
	     r:array of word;
	     g:array of word;
	     b:array of word;
	     a:array of word;
		 end;
	   maxy:word;
	   maxr:word;
	   maxg:word;
	   maxb:word;
	   maxa:word;
	   leni:word;
       end;
type tbuf=record
       sizetotal,sizeused:longword;
       valid:boolean;
       data:pointer;
       end;

function encodedef(ibuf:tbuf;destroy:boolean):tbuf;
function idx2tru(img:timage):timage;
function chkimg(img:timage):timage;
function cpimg(img:timage):timage;
function imgload(imgs:string):timage;
procedure pcxdump(img:timage;pcxs:string);
function pcxload(pcxs:string):timage;
procedure pngdump(img:timage;pngs:string);
function pngload(pngs:string):timage;
procedure pdfdump(img:timage;pdfs:string);
procedure epsdump(img:timage;epss:string);
function gifload(gifs:string):timage;
function tgaload(tgas:string):timage;
function bmpload(bmps:string):timage;

implementation

uses n2_mathe,dos,paszlib;

type
     byte4=array[0..3] of byte;
     byte5=array[0..4] of byte;
	 
function initbuf(size:longint):tbuf;
var buf:tbuf;
begin
  getmem(buf.data,size);
  buf.sizetotal:=size;
  buf.sizeused:=0;
  buf.valid:=true;
  initbuf:=buf;
end;

procedure donebuf(var buf:tbuf);
begin
  if buf.data<>nil then freemem(buf.data,buf.sizetotal);
  buf.data:=nil;
  buf.sizetotal:=0;
  buf.sizeused:=0;
  buf.valid:=false;
end;

procedure writebuf(buf:tbuf;srt,len,con:longint);
var i:longint;
begin
  for i:=0 to len-1 do
    byte((buf.data+(i+srt) div 8)^):=(byte((buf.data+(i+srt) div 8)^) and not (1 shl (7-((i+srt) and 7)))) or ((1 shl (7-((i+srt) and 7)))*((con shr (len-1-i)) and 1));
end;

function readbuf(buf:tbuf;srt,len:longint):longint;
var i,o:longint;
begin
  o:=0;
  for i:=0 to len-1 do
    o:=(o shl 1) or byte(byte((buf.data+(i+srt) div 8)^) and (1 shl (7-((i+srt) mod 8)))>0);
  readbuf:=o;
end;

function b42b5(b4:byte4;var n:byte):byte5;
var x,y:longword;
    i:byte;
    b5:byte5;
begin
  for i:=0 to 4 do b5[i]:=0;
  for i:=n to 3 do b4[i]:=0;
  x:=((b4[0]*256+b4[1])*256+b4[2])*256+b4[3];
  if (x=0) and (n=4) then
  begin
    b5[0]:=byte('z');
    n:=1;
  end
  else
  begin
    for i:=0 to 4 do
    begin
      y:=x div 85;
      b5[4-i]:=x-85*y+33;
      x:=y;
    end;
    n:=n+1;
  end;
  b42b5:=b5;
end;

function b52b4(b5:byte5;var n:byte):byte4;
var x:longword;
    i:byte;
    b4:byte4;
begin
  for i:=n to 4 do b5[i]:=33;
  if b5[0]=byte('z') then
  begin
    for i:=0 to 3 do b4[i]:=0;
    n:=4;
  end
  else
  begin
    x:=0;
    for i:=0 to 4 do x:=x*85+word(b5[i]-33)+byte((i=n-1) and (n<5));
    b4[3]:=x mod 256;
	x:=(x-b4[3]) div 256;
    b4[2]:=x mod 256;
	x:=(x-b4[2]) div 256;
    b4[1]:=x mod 256;
	x:=(x-b4[1]) div 256;
    b4[0]:=x mod 256;
    n:=n-1;
  end;
  b52b4:=b4;
end;

function decodea85(ibuf:tbuf;destroy:boolean):tbuf;
var obuf:tbuf;
    nz,i:longword;
    pi,po:longword;
    ni:byte;
    b4:byte4;
    b5:byte5;
begin
  nz:=0;
  for i:=0 to ibuf.sizeused-3 do if char((ibuf.data+i)^)='z' then inc(nz);
  obuf.sizetotal:=4*nz+4*((ibuf.sizeused-2-nz-1) div 5)+(ibuf.sizeused-2-nz-1) mod 5;
  getmem(obuf.data,obuf.sizetotal);
  {ASCII85 -> Byte}
  pi:=0;
  po:=0;
  while pi<ibuf.sizeused-2 do
  begin
    if char((ibuf.data+pi)^)='z' then
    begin
      for i:=0 to 3 do byte((obuf.data+po+i)^):=0;
      inc(pi);
      inc(po,4);
    end
    else
    begin
      ni:=0;
      while (ni<5) and (pi+ni<ibuf.sizeused-2) do
      begin
        b5[ni]:=byte((ibuf.data+pi+ni)^);
        inc(ni);
      end;
      inc(pi,ni);
      b4:=b52b4(b5,ni);
      for i:=0 to ni-1 do byte((obuf.data+po+i)^):=b4[i];
      inc(po,ni);
    end;
  end;
  obuf.sizeused:=po;
  if obuf.sizeused<>obuf.sizetotal then
  begin
    writeln('ASCII85 decoding error.');
    obuf.valid:=false;
    readln;
  end
  else obuf.valid:=true;
  if destroy then donebuf(ibuf);
  decodea85:=obuf;
end;

function decodedef(ibuf:tbuf;destroy:boolean):tbuf;
var obuf:tbuf;
    er:integer;
begin
  obuf.sizetotal:=2*ibuf.sizetotal+12;
  repeat
    getmem(obuf.data,obuf.sizetotal);
    obuf.sizeused:=obuf.sizetotal;
	er:=uncompress(pchar(obuf.data),obuf.sizeused,pchar(ibuf.data),ibuf.sizeused);
    if er=Z_BUF_ERROR then
    begin
      freemem(obuf.data,obuf.sizetotal);
      obuf.sizetotal:=2*obuf.sizetotal;
    end;
  until er<>Z_BUF_ERROR;
  obuf.valid:=(er=z_OK);
  if destroy then donebuf(ibuf);
  decodedef:=obuf;
end;

function encodea85(ibuf:tbuf;destroy:boolean):tbuf;
var nz,i,j:longword;
    obuf:tbuf;
    po:longword;
    no:byte;
    b5:byte5;
begin
  nz:=0;
  for i:=0 to ibuf.sizeused div 4-1 do if longint((ibuf.data+4*i)^)=0 then inc(nz);
  obuf.sizetotal:=2+nz+(5*(ibuf.sizeused-4*nz)+3) div 4;
  getmem(obuf.data,obuf.sizetotal);
  {Byte -> ASCII85}
  po:=0;
  for i:=0 to ibuf.sizeused div 4-1 do
  begin
    no:=4;
    b5:=b42b5(byte4((ibuf.data+4*i)^),no);
    for j:=0 to no-1 do byte((obuf.data+po+j)^):=b5[j];
    po:=po+no;
  end;
  no:=ibuf.sizeused mod 4;
  if no>0 then
  begin
    b5:=b42b5(byte4((ibuf.data+4*(ibuf.sizeused div 4))^),no);
    for j:=0 to no-1 do byte((obuf.data+po+j)^):=b5[j];
    inc(po,no);
  end;
  char((obuf.data+po)^):='~';
  inc(po);
  char((obuf.data+po)^):='>';
  inc(po);
  obuf.sizeused:=po;
  if obuf.sizeused<>obuf.sizetotal then
  begin
    writeln('ASCII85 encoding error.');
    obuf.valid:=false;
    readln;
  end
  else obuf.valid:=true;
  if destroy then donebuf(ibuf);
  encodea85:=obuf;
end;

function encodedef(ibuf:tbuf;destroy:boolean):tbuf;
var obuf:tbuf;
    er:integer;
begin
  obuf.sizetotal:=ibuf.sizetotal;
  repeat
    getmem(obuf.data,obuf.sizetotal);
    obuf.sizeused:=obuf.sizetotal;
	er:=compress2(pchar(obuf.data),obuf.sizeused,pchar(ibuf.data),ibuf.sizeused,5);
    if er=Z_BUF_ERROR then
    begin
      freemem(obuf.data,obuf.sizetotal);
      obuf.sizetotal:=2*obuf.sizetotal;
    end;
  until er<>Z_BUF_ERROR;
  obuf.valid:=(er=z_OK);
  if destroy then donebuf(ibuf);
  encodedef:=obuf;
end;

function idx2tru(img:timage):timage;
var i,j:longint;
begin
  if img.imgtype=idx then
  begin
    img.imgtype:=tru;
	case img.coltype of
	y:
	  begin
	    setlength(img.img.y,img.sy,img.sx);
	    for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do img.img.y[j,i]:=img.pal.y[img.img.i[j,i]];
	  end;
	ya:
	  begin
		setlength(img.img.y,img.sy,img.sx);
		setlength(img.img.a,img.sy,img.sx);
	    for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do 
		begin
		  img.img.y[j,i]:=img.pal.y[img.img.i[j,i]];
		  img.img.a[j,i]:=img.pal.a[img.img.i[j,i]];
		end;
	  end;
	rgb:
	  begin
		setlength(img.img.r,img.sy,img.sx);
		setlength(img.img.g,img.sy,img.sx);
		setlength(img.img.b,img.sy,img.sx);
	    for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do 
		begin
		  img.img.r[j,i]:=img.pal.r[img.img.i[j,i]];
		  img.img.g[j,i]:=img.pal.g[img.img.i[j,i]];
		  img.img.b[j,i]:=img.pal.b[img.img.i[j,i]];
		end;
	  end;
	rgba:
	  begin
		setlength(img.img.r,img.sy,img.sx);
		setlength(img.img.g,img.sy,img.sx);
		setlength(img.img.b,img.sy,img.sx);
		setlength(img.img.a,img.sy,img.sx);
	    for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do 
		begin
		  img.img.r[j,i]:=img.pal.r[img.img.i[j,i]];
		  img.img.g[j,i]:=img.pal.g[img.img.i[j,i]];
		  img.img.b[j,i]:=img.pal.b[img.img.i[j,i]];
		  img.img.a[j,i]:=img.pal.a[img.img.i[j,i]];
		end;
	  end;
	end;
	setlength(img.img.i,0);
	img.leni:=0;
  end;
  idx2tru:=img;
end;

function chkimg(img:timage):timage;
var ff:boolean;
	i,j:longint;
begin
  if (img.coltype in [rgba,ya]) and (img.maxa=0) then
  begin
    case img.imgtype of
	idx: setlength(img.pal.a,0);
	tru: setlength(img.img.a,0,0);
	end;
	case img.coltype of
	rgba: img.coltype:=rgb;
	ya:   img.coltype:=y;
	end;
  end;
  if (img.sx=0) or (img.sy=0) then writeln('chkimg: unset image size');
  case img.imgtype of
  idx: begin
         if img.leni=0 then writeln('chkimg: unset index length');
		 if (length(img.img.r)>0) or (length(img.img.g)>0) or (length(img.img.b)>0) or (length(img.img.y)>0) or (length(img.img.a)>0) then writeln('chkimg: unused component field');
		 if (length(img.img.i)<>img.sy) or ((length(img.img.i)>0) and (length(img.img.i[0])<>img.sx)) then writeln('chkimg: uncorrect index field size')
		 else
		 begin
		   ff:=false;
		   for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do ff:=ff or (img.img.i[j,i]>=img.leni);
		   if ff then writeln('chkimg: index exceeds palette length');
		 end;
		 ff:=false;
		 case img.coltype of
		 rgb,rgba: 
		   begin
			 ff:=ff or (length(img.pal.r)<>img.leni);
			 ff:=ff or (length(img.pal.g)<>img.leni);
			 ff:=ff or (length(img.pal.b)<>img.leni);
			 ff:=ff or (length(img.pal.y)>0);
		   end;
		 y,ya: 
		   begin
			 ff:=ff or (length(img.pal.r)>0);
			 ff:=ff or (length(img.pal.g)>0);
			 ff:=ff or (length(img.pal.b)>0);
			 ff:=ff or (length(img.pal.y)<>img.leni);
		   end;
		 end;
		 ff:=ff or ((img.coltype in [ya,rgba]) and (length(img.pal.a)<>img.leni)) or ((img.coltype in [y,rgb]) and (length(img.pal.a)>0));
		 if ff then writeln('chkimg: uncorrect palette component length')
		 else
		 begin
		   ff:=false;
		   case img.coltype of
		   rgb: for i:=0 to img.leni-1 do ff:=ff or (img.pal.r[i]>img.maxr) or (img.pal.g[i]>img.maxg) or (img.pal.b[i]>img.maxb);
		   rgba: for i:=0 to img.leni-1 do ff:=ff or (img.pal.r[i]>img.maxr) or (img.pal.g[i]>img.maxg) or (img.pal.b[i]>img.maxb) or (img.pal.a[i]>img.maxa);
		   y: for i:=0 to img.leni-1 do ff:=ff or (img.pal.y[i]>img.maxy);
		   ya: for i:=0 to img.leni-1 do ff:=ff or (img.pal.y[i]>img.maxy) or (img.pal.a[i]>img.maxa);
		   end;
		   if ff then writeln('chkimg: palette entry exceeds component maximum');
		 end;
	   end;	 
  tru: begin	 
         if (length(img.img.i)>0) then writeln('chkimg: unused index field');
		 ff:=false;
		 case img.coltype of
		 rgb: ff:=ff or ((length(img.img.r)<>img.sy) or ((length(img.img.r)>0) and (length(img.img.r[0])<>img.sx)))
		             or ((length(img.img.g)<>img.sy) or ((length(img.img.g)>0) and (length(img.img.g[0])<>img.sx)))
		             or ((length(img.img.b)<>img.sy) or ((length(img.img.b)>0) and (length(img.img.b[0])<>img.sx)))
		             or (length(img.img.y)>0)
		             or (length(img.img.a)>0);
		 rgba: ff:=ff or ((length(img.img.r)<>img.sy) or ((length(img.img.r)>0) and (length(img.img.r[0])<>img.sx)))
		             or ((length(img.img.g)<>img.sy) or ((length(img.img.g)>0) and (length(img.img.g[0])<>img.sx)))
		             or ((length(img.img.b)<>img.sy) or ((length(img.img.b)>0) and (length(img.img.b[0])<>img.sx)))
		             or ((length(img.img.a)<>img.sy) or ((length(img.img.a)>0) and (length(img.img.a[0])<>img.sx)))
		             or (length(img.img.y)>0);
		 ya: ff:=ff or ((length(img.img.y)<>img.sy) or ((length(img.img.y)>0) and (length(img.img.y[0])<>img.sx)))
		             or ((length(img.img.a)<>img.sy) or ((length(img.img.a)>0) and (length(img.img.a[0])<>img.sx)))
		             or (length(img.img.r)>0)
		             or (length(img.img.g)>0)
		             or (length(img.img.b)>0);
		 y: ff:=ff or ((length(img.img.y)<>img.sy) or ((length(img.img.y)>0) and (length(img.img.y[0])<>img.sx)))
					 or (length(img.img.r)>0)
		             or (length(img.img.g)>0)
		             or (length(img.img.b)>0)
		             or (length(img.img.a)>0);
		 end;
		 if ff then writeln('chkimg: uncorrect component field size')
		 else
		 begin
		   ff:=false;
		   case img.coltype of
		   rgb: for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do ff:=ff or (img.img.r[j,i]>img.maxr) or (img.img.g[j,i]>img.maxg) or (img.img.b[j,i]>img.maxb);
		   rgba: for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do ff:=ff or (img.img.r[j,i]>img.maxr) or (img.img.g[j,i]>img.maxg) or (img.img.b[j,i]>img.maxb) or (img.img.a[j,i]>img.maxa);
		   ya: for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do ff:=ff or (img.img.y[j,i]>img.maxy) or (img.img.a[j,i]>img.maxa);
		   y: for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do ff:=ff or (img.img.y[j,i]>img.maxy);
		   end;
		   if ff then writeln('chkimg: component entry exceeds component maximum');
		 end;
	   end;
  end;
  chkimg:=img;
end;

function resetimg:timage;
var	img:timage;
begin
  img.sx:=0;
  img.sy:=0;
  img.imgtype:=idx;
  img.leni:=0;
  img.coltype:=rgb;
  img.maxr:=0;
  img.maxg:=0;
  img.maxb:=0;
  img.maxy:=0;
  img.maxa:=0;
  setlength(img.img.i,0,0);
  setlength(img.img.r,0,0);
  setlength(img.img.g,0,0);
  setlength(img.img.b,0,0);
  setlength(img.img.y,0,0);
  setlength(img.img.a,0,0);
  setlength(img.pal.r,0);
  setlength(img.pal.g,0);
  setlength(img.pal.b,0);
  setlength(img.pal.y,0);
  setlength(img.pal.a,0);
  resetimg:=img;
end;

function cpimg(img:timage):timage;
var img2:timage;
	i,j:longint;
begin
	img2.imgtype:=img.imgtype;
	img2.coltype:=img.coltype;
	img2.sx:=img.sx;
	img2.sy:=img.sy;
	case img2.imgtype of
	idx:
	  begin
        setlength(img2.img.i,img2.sy,img2.sx);
		for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.i[j,i]:=img.img.i[j,i];
		setlength(img2.img.r,0,0);
		setlength(img2.img.g,0,0);
		setlength(img2.img.b,0,0);
		setlength(img2.img.y,0,0);
		setlength(img2.img.a,0,0);
		img2.leni:=img.leni;
        case img2.coltype of
		rgb:
		  begin
		    setlength(img2.pal.r,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.r[i]:=img.pal.r[i];
			img2.maxr:=img.maxr;
		    setlength(img2.pal.g,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.g[i]:=img.pal.g[i];
			img2.maxg:=img.maxg;
		    setlength(img2.pal.b,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.b[i]:=img.pal.b[i];
			img2.maxb:=img.maxb;
		    setlength(img2.pal.y,0);
			img2.maxy:=0;
		    setlength(img2.pal.a,0);
			img2.maxa:=0;
		  end;
		rgba:
		  begin
		    setlength(img2.pal.r,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.r[i]:=img.pal.r[i];
			img2.maxr:=img.maxr;
		    setlength(img2.pal.g,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.g[i]:=img.pal.g[i];
			img2.maxg:=img.maxg;
		    setlength(img2.pal.b,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.b[i]:=img.pal.b[i];
			img2.maxb:=img.maxb;
		    setlength(img2.pal.y,0);
			img2.maxy:=0;
		    setlength(img2.pal.a,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.a[i]:=img.pal.a[i];
			img2.maxa:=img.maxa;
		  end;
		y:
		  begin
		    setlength(img2.pal.r,0);
			img2.maxr:=0;
		    setlength(img2.pal.g,0);
			img2.maxg:=0;
		    setlength(img2.pal.b,0);
			img2.maxb:=0;
		    setlength(img2.pal.y,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.y[i]:=img.pal.y[i];
			img2.maxy:=img.maxy;
		    setlength(img2.pal.a,0);
			img2.maxa:=0;
		  end;
		ya:
		  begin
		    setlength(img2.pal.r,0);
			img2.maxr:=0;
		    setlength(img2.pal.g,0);
			img2.maxg:=0;
		    setlength(img2.pal.b,0);
			img2.maxb:=0;
		    setlength(img2.pal.y,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.y[i]:=img.pal.y[i];
			img2.maxy:=img.maxy;
		    setlength(img2.pal.a,img2.leni);
			for i:=0 to img2.leni-1 do img2.pal.a[i]:=img.pal.a[i];
			img2.maxa:=img.maxa;
		  end;
		end;
	  end;
	tru:
	  begin
		img2.leni:=0;
		setlength(img2.img.i,0,0);
		setlength(img2.pal.r,0);
		setlength(img2.pal.g,0);
		setlength(img2.pal.b,0);
		setlength(img2.pal.y,0);
		setlength(img2.pal.a,0);
        case img2.coltype of
		rgb:
		  begin
			setlength(img2.img.r,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.r[j,i]:=img.img.r[j,i];
			img2.maxr:=img.maxr;
			setlength(img2.img.g,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.g[j,i]:=img.img.g[j,i];
			img2.maxg:=img.maxg;
			setlength(img2.img.b,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.b[j,i]:=img.img.b[j,i];
			img2.maxb:=img.maxb;
			setlength(img2.img.y,0,0);
			img2.maxy:=0;
			setlength(img2.img.a,0,0);
			img2.maxa:=0;
		  end;
		rgba:
		  begin
			setlength(img2.img.r,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.r[j,i]:=img.img.r[j,i];
			img2.maxr:=img.maxr;
			setlength(img2.img.g,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.g[j,i]:=img.img.g[j,i];
			img2.maxg:=img.maxg;
			setlength(img2.img.b,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.b[j,i]:=img.img.b[j,i];
			img2.maxb:=img.maxb;
			setlength(img2.img.y,0,0);
			img2.maxy:=0;
			setlength(img2.img.a,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.a[j,i]:=img.img.a[j,i];
			img2.maxa:=img.maxa;
		  end;
		y:
		  begin
			setlength(img2.img.r,0,0);
			img2.maxr:=0;
			setlength(img2.img.g,0,0);
			img2.maxg:=0;
			setlength(img2.img.b,0,0);
			img2.maxb:=0;
			setlength(img2.img.y,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.y[j,i]:=img.img.y[j,i];
			img2.maxy:=img.maxy;
			setlength(img2.img.a,0,0);
			img2.maxa:=0;
		  end;
		ya:
		  begin
			setlength(img2.img.r,0,0);
			img2.maxr:=0;
			setlength(img2.img.g,0,0);
			img2.maxg:=0;
			setlength(img2.img.b,0,0);
			img2.maxb:=0;
			setlength(img2.img.y,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.y[j,i]:=img.img.y[j,i];
			img2.maxy:=img.maxy;
			setlength(img2.img.a,img2.sy,img2.sx);
			for j:=0 to img2.sy-1 do for i:=0 to img2.sx-1 do img2.img.a[j,i]:=img.img.a[j,i];
			img2.maxa:=img.maxa;
		  end;
		end;	  
	  end;
	end;
	cpimg:=img2;
end;

function imgload(imgs:string):timage;
var dir:dirstr;
    name:namestr;
    ext:extstr;
function downstring(e:extstr):string;
var s:string;
	i:longint;
begin
  s:='';
  for i:=1 to length(e) do s:=s+lowercase(e[i]);
  downstring:=s;
end;
begin
  fsplit(imgs,dir,name,ext);
  imgload:=resetimg;
  if downstring(ext)='.bmp' then imgload:=bmpload(imgs);
  if downstring(ext)='.pcx' then imgload:=pcxload(imgs);
  if (downstring(ext)='.tga') or (downstring(ext)='.tpic') then imgload:=tgaload(imgs);
  if downstring(ext)='.gif' then imgload:=gifload(imgs);
  if downstring(ext)='.png' then imgload:=pngload(imgs);
end;

procedure pcxdump(img:timage;pcxs:string);
var pcxf:file;
    pcxh:array[0..$7f] of byte;
	cx,co:byte;
	ix,iy,ii,bpsl:longint;
procedure pushout(b:byte;var c:byte);
begin
  if (c=1) and (b<$c0) then
  begin
    blockwrite(pcxf,b,1);
    c:=0;
  end
  else
  begin
    c:=c+$c0;
    blockwrite(pcxf,c,1);
    blockwrite(pcxf,b,1);
    c:=0;
  end;
end;
procedure upbyte(b:byte;e:boolean);
begin
  if cx=0 then co:=b;
  if (b<>co) or (cx=$3f) then
  begin
    pushout(co,cx);
    co:=b;
  end;
  if b=co then inc(cx);
  co:=b;
  if e then pushout(b,cx);
end;
procedure startf;
var i:longint;
begin
  assign(pcxf,pcxs);
  rewrite(pcxf,1);
  pcxh[$00]:=$0a;
  pcxh[$04]:=0;
  pcxh[$05]:=0;
  pcxh[$06]:=0;
  pcxh[$07]:=0;
  pcxh[$08]:=(img.sx-1) mod 256;
  pcxh[$09]:=(img.sx-1) div 256;
  pcxh[$0a]:=(img.sy-1) mod 256;
  pcxh[$0b]:=(img.sy-1) div 256;
  pcxh[$0c]:=0;
  pcxh[$0d]:=0;
  pcxh[$0e]:=0;
  pcxh[$0f]:=0;
  for i:=0 to 15 do pcxh[$10+3*i+0]:=85*(i div 8 + 2*((i mod 8) div 4));
  for i:=0 to 15 do pcxh[$10+3*i+1]:=85*(i div 8 + 2*((i mod 4) div 2)-byte(i=6));
  for i:=0 to 15 do pcxh[$10+3*i+2]:=85*(i div 8 + 2*((i mod 2) div 1));
  for i:=$46 to $7f do pcxh[i]:=$00;
end;
begin
  if img.coltype in [rgb,y] then
  begin
    case img.imgtype of
    tru: case img.coltype of
	  rgb: if (img.maxr<=255) and (img.maxg<=255) and (img.maxb<=255) then
		begin
		  startf;
          pcxh[$01]:=$05;
		  pcxh[$02]:=$01;
		  pcxh[$03]:=$08;
		  pcxh[$40]:=$00;
		  pcxh[$41]:=$03;
		  bpsl:=2*((img.sx-1) div 2+1);
		  pcxh[$42]:=bpsl mod 256;
		  pcxh[$43]:=bpsl div 256;
		  pcxh[$44]:=$01;
		  pcxh[$45]:=$00;
		  blockwrite(pcxf,pcxh,sizeof(pcxh));
		  cx:=0;
		  for iy:=0 to img.sy-1 do
		  begin
		    for ix:=0 to bpsl-1 do if ix<img.sx then upbyte(round(255*img.img.r[iy,ix]/img.maxr),ix=bpsl-1) else upbyte(co,ix=bpsl-1);
		    for ix:=0 to bpsl-1 do if ix<img.sx then upbyte(round(255*img.img.g[iy,ix]/img.maxg),ix=bpsl-1) else upbyte(co,ix=bpsl-1);
		    for ix:=0 to bpsl-1 do if ix<img.sx then upbyte(round(255*img.img.b[iy,ix]/img.maxb),ix=bpsl-1) else upbyte(co,ix=bpsl-1);
		  end;
		  close(pcxf);
	    end
	    else writeln('pcxdump: color component maximum exceeds bounds');
	  y: if img.maxy<=255 then
		begin
		  startf;
          pcxh[$01]:=$05;
		  pcxh[$02]:=$01;
		  pcxh[$03]:=$08;
		  pcxh[$40]:=$00;
		  pcxh[$41]:=$01;
		  bpsl:=2*((img.sx-1) div 2+1);
		  pcxh[$42]:=bpsl mod 256;
		  pcxh[$43]:=bpsl div 256;
		  pcxh[$44]:=$02;
		  pcxh[$45]:=$00;
		  blockwrite(pcxf,pcxh,sizeof(pcxh));
		  cx:=0;
		  for iy:=0 to img.sy-1 do for ix:=0 to bpsl-1 do if ix<img.sx then upbyte(round(255*img.img.y[iy,ix]/img.maxy),ix=bpsl-1) else upbyte(co,ix=bpsl-1);
		  co:=$0c;
		  blockwrite(pcxf,co,1);
		  for ii:=0 to 255 do 
		  begin
			co:=ii;
			blockwrite(pcxf,co,1);
			blockwrite(pcxf,co,1);
			blockwrite(pcxf,co,1);
		  end;
		  close(pcxf);
	    end
	    else writeln('pcxdump: gray maximum exceeds bounds');
	  end;
    idx: if ((img.coltype=rgb) and (img.maxr<=255) and (img.maxg<=255) and (img.maxb<=255)) or ((img.coltype=y) and (img.maxy<=255)) then
	  begin
	    if img.leni<=256 then
        begin
{
	      if img.leni<=16 then
          begin
		    if img.leni<=2 then
            begin
//		      2c
		    end
		    else
		    begin
//		      16c
		    end;
		  end
		  else
		  begin
}
		    startf;
		    pcxh[$01]:=$05;
		    pcxh[$02]:=$01;
		    pcxh[$03]:=$08;
		    pcxh[$40]:=$00;
		    pcxh[$41]:=$01;
			bpsl:=2*((img.sx-1) div 2+1);
			pcxh[$42]:=bpsl mod 256;
			pcxh[$43]:=bpsl div 256;
		    pcxh[$44]:=$01+byte(img.coltype=y);
		    pcxh[$45]:=$00;
		    blockwrite(pcxf,pcxh,sizeof(pcxh));
		    cx:=0;
		    for iy:=0 to img.sy-1 do for ix:=0 to bpsl-1 do if ix<img.sx then upbyte(img.img.i[iy,ix],ix=bpsl-1) else upbyte(co,ix=bpsl-1);
			co:=$0c;
			blockwrite(pcxf,co,1);
            for ii:=0 to img.leni-1 do 
		    begin
			  if img.coltype=rgb then co:=round(255*img.pal.r[ii]/img.maxr) else co:=round(255*img.pal.y[ii]/img.maxy);
			  blockwrite(pcxf,co,1);
			  if img.coltype=rgb then co:=round(255*img.pal.g[ii]/img.maxg);
			  blockwrite(pcxf,co,1);
			  if img.coltype=rgb then co:=round(255*img.pal.b[ii]/img.maxb);
			  blockwrite(pcxf,co,1);
		    end;
			co:=0;
            for ii:=3*img.leni to 3*255+2 do blockwrite(pcxf,co,1);
		    close(pcxf);
//		  end;
        end
	    else 
		begin
		  writeln('pcxdump: index maximum exceeds bounds ... trying true color');
		  pcxdump(idx2tru(img),pcxs);
		end;
      end
	  else writeln('pcxdump: color or gray component maximum exceeds bounds');
	end;
  end
  else writeln('pcxdump: no alpha channel');
end;

function pcxload(pcxs:string):timage;
var pcxf:file;
    pcxa:array[0..$7f] of byte;
    ncol,bpsl,ib,ic,ix,iy:word;
    i:longint;
    bd:byte;
	img:timage;
procedure putbyte2(b:byte);
var ii:longint;
begin
  for ii:=0 to 7 do if ix<img.sx then
  begin
    img.img.y[iy,ix]:=(b shr (7-ii)) mod 2;
    inc(ix);
  end;
end;
procedure putbyte16(b:byte);
var ii:longint;
begin
  for ii:=0 to 7 do if ix<img.sx then
  begin
    img.img.i[iy,ix]:=img.img.i[iy,ix]+((b shr (7-ii)) mod 2)*(1 shl ic);
    inc(ix);
  end;
end;
procedure putbyte16x(b:byte);
var ii:longint;
begin
  for ii:=0 to 1 do if ix<img.sx then
  begin
    img.img.i[iy,ix]:=(b shr (4-4*ii)) mod 16;
    inc(ix);
  end;
end;
procedure putbyte256(b:byte);
begin
  if ix<img.sx then
  begin
    img.img.i[iy,ix]:=b;
    inc(ix);
  end;
end;
procedure putbyte24(b:byte);
begin
  if ix<img.sx then
  begin
    case ic of
    0: img.img.r[iy,ix]:=b;
    1: img.img.g[iy,ix]:=b;
    2: img.img.b[iy,ix]:=b;
    end;
    inc(ix);
  end;
end;
procedure pcxproc(cm:byte);
var b1,b2,il:byte;
begin
  ix:=0;
  iy:=0;
  ib:=0;
  ic:=0;
  while iy<img.sy do
  begin
	blockread(pcxf,b1,1);
	if b1<$c0 then 
	begin
	  case cm of
	  0: putbyte2(b1);
	  1: putbyte16(b1);
	  2: putbyte16x(b1);
	  3: putbyte256(b1);
	  4: putbyte24(b1);
	  end;
	  inc(ib);
	end
	else
	begin
	  blockread(pcxf,b2,1);
	  for il:=0 to b1-$c0-1 do 
	  begin
	    case cm of
	    0: putbyte2(b2);
	    1: putbyte16(b2);
	    2: putbyte16x(b2);
	    3: putbyte256(b2);
	    4: putbyte24(b2);
		end;
	  end;
	  inc(ib,b1-$c0);
	end;
	if ib>=bpsl then 
	begin
	  ix:=0;
	  ib:=0;
	  inc(ic);
	  if ic>=ncol then
	  begin
	    ic:=0;
	    inc(iy);  
	  end;
	end;
  end;
end;
begin
  img:=resetimg;
  assign(pcxf,pcxs);
  reset(pcxf,1);
  if ioresult=0 then
  begin
    blockread(pcxf,pcxa,$80);
    if (pcxa[0]=10) and (pcxa[1] in [0,2,3,5]) and (pcxa[2]=1) and
      (((pcxa[3]=1) and (pcxa[$41]=1)) {2 Farben} or
      ((pcxa[3]=1) and (pcxa[$41]=4)) {16 Farben} or
      ((pcxa[3]=4) and (pcxa[$41]=1)) {16 Farben} or
      ((pcxa[3]=8) and (pcxa[$41]=1)) {256 Farben} or
      ((pcxa[3]=8) and (pcxa[$41]=3))) {24 bit true color} then
    begin
      ncol:=pcxa[$41];
      bpsl:=pcxa[$42]+256*pcxa[$43];
	  img.sx:=pcxa[$08]+256*pcxa[$09]+1;
	  img.sy:=pcxa[$0a]+256*pcxa[$0b]+1;      
	  if (pcxa[3]=1) and (pcxa[$41]=1) then 
	  begin
	    img.imgtype:=tru;
		img.coltype:=y;
		img.maxy:=1;
		setlength(img.img.y,img.sy,img.sx);
        pcxproc(0);
	  end;
      if (pcxa[3]=1) and (pcxa[$41]=4) then 
	  begin
	    img.imgtype:=idx;
		img.coltype:=rgb;
	    img.maxr:=255;
	    img.maxg:=255;
	    img.maxb:=255;
	    img.leni:=16;
		setlength(img.pal.r,img.leni);
		setlength(img.pal.g,img.leni);
		setlength(img.pal.b,img.leni);
		setlength(img.img.i,img.sy,img.sx);
		for i:=0 to 15 do
        begin
          img.pal.r[i]:=85*(i div 8 + 2*((i mod 8) div 4));
          img.pal.g[i]:=85*(i div 8 + 2*((i mod 4) div 2)-byte(i=6));
          img.pal.b[i]:=85*(i div 8 + 2*((i mod 2) div 1));
        end;
        if pcxa[1] in [0,2,5] then
        begin
          {Palette nachladen 16 Farben}
          for i:=0 to 15 do
          begin
            img.pal.r[i]:=pcxa[$10+3*i+0];
            img.pal.g[i]:=pcxa[$10+3*i+1];
            img.pal.b[i]:=pcxa[$10+3*i+2];
          end;
        end;
		for iy:=0 to img.sy-1 do for ix:=0 to img.sx-1 do img.img.i[iy,ix]:=0;
        pcxproc(1);
	  end;
      if (pcxa[3]=4) and (pcxa[$41]=1) then 
	  begin
	    img.imgtype:=idx;
		img.coltype:=rgb;
	    img.maxr:=255;
	    img.maxg:=255;
	    img.maxb:=255;
	    img.leni:=16;
		setlength(img.pal.r,img.leni);
		setlength(img.pal.g,img.leni);
		setlength(img.pal.b,img.leni);
		setlength(img.img.i,img.sy,img.sx);
        for i:=0 to 15 do
        begin
          img.pal.r[i]:=pcxa[$10+3*i+0];
          img.pal.g[i]:=pcxa[$10+3*i+1];
          img.pal.b[i]:=pcxa[$10+3*i+2];
        end;
        pcxproc(2);
	  end;
      if (pcxa[3]=8) and (pcxa[$41]=1) then
	  begin
	    img.imgtype:=idx;
		img.coltype:=rgb;
	    img.maxr:=255;
	    img.maxg:=255;
	    img.maxb:=255;
	    img.leni:=256;
		setlength(img.pal.r,img.leni);
		setlength(img.pal.g,img.leni);
		setlength(img.pal.b,img.leni);
		setlength(img.img.i,img.sy,img.sx);
        for i:=0 to 15 do
        begin
          img.pal.r[i]:=85*(i div 8 + 2*((i mod 8) div 4));
          img.pal.g[i]:=85*(i div 8 + 2*((i mod 4) div 2)-byte(i=6));
          img.pal.b[i]:=85*(i div 8 + 2*((i mod 2) div 1));
        end;
        for i:=16 to 255 do
        begin
          img.pal.r[i]:=i;
          img.pal.g[i]:=i;
          img.pal.b[i]:=i;
        end;
		pcxproc(3);
		if not eof(pcxf) then
		begin
		  blockread(pcxf,bd,1);
//		  if bd=$0c then
		  begin
            for i:=0 to 255 do
            begin
		      blockread(pcxf,img.pal.r[i],1);
		      blockread(pcxf,img.pal.g[i],1);
		      blockread(pcxf,img.pal.b[i],1);
			end;
          end;
		end;
	  end;
      if (pcxa[3]=8) and (pcxa[$41]=3) then 
	  begin
	    img.imgtype:=tru;
		img.coltype:=rgb;
	    img.maxr:=255;
	    img.maxg:=255;
	    img.maxb:=255;
		setlength(img.img.r,img.sy,img.sx);
		setlength(img.img.g,img.sy,img.sx);
		setlength(img.img.b,img.sy,img.sx);
		pcxproc(4);
	  end;
    end
    else writeln('pcxload: unknown pcx format in '+pcxs);
    close(pcxf);
  end
  else writeln('pcxload: file '+pcxs+' not found');
  pcxload:=img;
end;

procedure pngdump(img:timage;pngs:string);
var pngf:file;
    i,j:longint;
    chd:pointer;
    chl:longint;
    dpng:tbuf;
	bitd:byte;
	maxc:word;
	bpsl:longint;
procedure write1byte(p:longint;b:byte);
begin
  byte((chd+p)^):=b;
end;
procedure write2byte(p:longint;w:word);
begin
  byte((chd+p+1)^):=w mod 256;
  w:=(w-byte((chd+p+1)^)) div 256;
  byte((chd+p+0)^):=w mod 256;
end;
procedure write4byte(p:longint;l:longword);
begin
  byte((chd+p+3)^):=l mod 256;
  l:=(l-byte((chd+p+3)^)) div 256;
  byte((chd+p+2)^):=l mod 256;
  l:=(l-byte((chd+p+2)^)) div 256;
  byte((chd+p+1)^):=l mod 256;
  l:=(l-byte((chd+p+1)^)) div 256;
  byte((chd+p+0)^):=l mod 256;
end;
procedure writechunktype(p:longint;s:string);
begin
  char((chd+p)^):=s[1];
  char((chd+p+1)^):=s[2];
  char((chd+p+2)^):=s[3];
  char((chd+p+3)^):=s[4];
end;
function crc:longword;
var crctable:array[0..255] of longword;
    computed:boolean;
procedure makecrctable;
var c:longword;
    n,k:byte;
begin
  for n:=0 to 255 do
  begin
    c:=n;
    for k:=0 to 7 do
    begin
      if c and 1>0
      then c:=$edb88320 XOR (c shr 1)
      else c:=c shr 1;
    end;
    crctable[n]:=c;
  end;
  computed:=true;
end;
function updatecrc(crc:longword;buf:pointer;len:longword):longword;
var c,n:longword;
begin
  c:=crc;
  if not computed then makecrctable;
  for n:=0 to len-1 do c:=crctable[(c XOR byte((buf+n)^)) AND $ff] XOR (c shr 8);
  updatecrc:=c
end;
begin
  computed:=false;
  crc:=updatecrc($ffffffff,(chd+4),chl-8) XOR $ffffffff;
end;
procedure twrite(var f:file;t:string);
begin
  blockwrite(f,t[1],byte(t[0]));
end;
begin
  if (img.imgtype=tru) or ((img.imgtype=idx) and (img.leni<=256) and (((img.coltype=rgb) and (img.maxr<256) and (img.maxg<256) and (img.maxb<256)) 
    or ((img.coltype=rgba) and (img.maxr<256) and (img.maxg<256) and (img.maxb<256) and (img.maxa<256)) 
	or ((img.coltype=y) and (img.maxy<256)) or ((img.coltype=ya) and (img.maxy<256) and (img.maxa<256)))) then
  begin
    assign(pngf,pngs);
    rewrite(pngf,1);
    twrite(pngf,#137+#80+#78+#71+#13+#10+#26+#10);

    {Chunk IHDR}
    chl:=13+12;
    getmem(chd,chl);
    write4byte(0+8,img.sx);
    write4byte(4+8,img.sy);
    case img.imgtype of
    idx: bitd:=8; {index and color bit depth always 8}
    tru: case img.coltype of
	  rgb: bitd:=8+8*byte(maxi(img.maxr,maxi(img.maxg,img.maxb))>255);
	  rgba: bitd:=8+8*byte(maxi(img.maxr,maxi(img.maxg,maxi(img.maxb,img.maxa)))>255);
	  y: bitd:=8+8*byte(img.maxy>255);
	  ya: bitd:=8+8*byte(maxi(img.maxy,img.maxa)>255);
	  end; {color bit depth 8 or 16}
    end;
	write1byte(8+8,bitd);
    case img.imgtype of
    idx: write1byte(9+8,3);
    tru: case img.coltype of
       y:  write1byte(9+8,0);
       rgb:   write1byte(9+8,2);
       ya: write1byte(9+8,4);
       rgba:  write1byte(9+8,6);
       end;
    end;
    write1byte(10+8,0);
    write1byte(11+8,0);
    write1byte(12+8,0);

    write4byte(0,chl-12);
    writechunktype(4,'IHDR');
    write4byte(chl-4,crc);

    blockwrite(pngf,chd^,chl);
    freemem(chd,chl);

	maxc:=(longint(1) shl bitd)-1;

    {Chunk PLTE}
    if img.imgtype=idx then
    begin
      chl:=3*256+12;
      getmem(chd,chl);

      case img.coltype of
      y,ya: for i:=0 to img.leni-1 do
		begin
		  write1byte(3*i+8,round(maxc*img.pal.y[i]/img.maxy));
		  write1byte(3*i+1+8,round(maxc*img.pal.y[i]/img.maxy));
		  write1byte(3*i+2+8,round(maxc*img.pal.y[i]/img.maxy));
		end;
      rgb,rgba: for i:=0 to img.leni-1 do
		begin
		  write1byte(3*i+8,round(maxc*img.pal.r[i]/img.maxr));
		  write1byte(3*i+1+8,round(maxc*img.pal.g[i]/img.maxg));
		  write1byte(3*i+2+8,round(maxc*img.pal.b[i]/img.maxb));
		end;
      end;
	  for i:=3*img.leni to 3*256-1 do write1byte(i+8,0);

      write4byte(0,chl-12);
      writechunktype(4,'PLTE');
      write4byte(chl-4,crc);

      blockwrite(pngf,chd^,chl);
      freemem(chd,chl);
    end;

    {Chunk tRNS}
    if (img.imgtype=idx) and (img.coltype in [ya,rgba]) then
    begin
      chl:=256+12;
      getmem(chd,chl);
      for i:=0 to img.leni-1 do write1byte(i+8,round(maxc*img.pal.a[i]/img.maxa));
      for i:=img.leni to 255 do write1byte(i+8,0);

      write4byte(0,chl-12);
      writechunktype(4,'tRNS');
      write4byte(chl-4,crc);

      blockwrite(pngf,chd^,chl);
      freemem(chd,chl);
    end;

    {Chunk IDAT}
	case img.imgtype of
    idx: bpsl:=img.sx;
	tru: case img.coltype of
	  rgb: bpsl:=3*(bitd div 8)*img.sx;
	  rgba: bpsl:=4*(bitd div 8)*img.sx;
	  y: bpsl:=1*(bitd div 8)*img.sx;
	  ya: bpsl:=2*(bitd div 8)*img.sx;
	  end;
    end;
    dpng:=initbuf(img.sy*(bpsl+1));
    for j:=0 to img.sy-1 do
    begin
	  writebuf(dpng,8*j*(bpsl+1),8,0);
      for i:=0 to img.sx-1 do case img.imgtype of
      idx: writebuf(dpng,8*j*(bpsl+1)+i*bitd+8,8,img.img.i[j,i]);
	  tru:      
	    case img.coltype of
	      rgb:
		    begin
			  writebuf(dpng,8*j*(bpsl+1)+(3*i)*bitd+8,bitd,round(maxc*img.img.r[j,i]/img.maxr));
			  writebuf(dpng,8*j*(bpsl+1)+(3*i+1)*bitd+8,bitd,round(maxc*img.img.g[j,i]/img.maxg));
			  writebuf(dpng,8*j*(bpsl+1)+(3*i+2)*bitd+8,bitd,round(maxc*img.img.b[j,i]/img.maxb));
		    end;
	      rgba:
		    begin
			  writebuf(dpng,8*j*(bpsl+1)+(4*i)*bitd+8,bitd,round(maxc*img.img.r[j,i]/img.maxr));
			  writebuf(dpng,8*j*(bpsl+1)+(4*i+1)*bitd+8,bitd,round(maxc*img.img.g[j,i]/img.maxg));
			  writebuf(dpng,8*j*(bpsl+1)+(4*i+2)*bitd+8,bitd,round(maxc*img.img.b[j,i]/img.maxb));
			  writebuf(dpng,8*j*(bpsl+1)+(4*i+3)*bitd+8,bitd,round(maxc*img.img.a[j,i]/img.maxa));
		    end;
		  y:
			  writebuf(dpng,8*j*(bpsl+1)+i*bitd+8,bitd,round(maxc*img.img.y[j,i]/img.maxy));
		  ya:
		    begin
			  writebuf(dpng,8*j*(bpsl+1)+(2*i)*bitd+8,bitd,round(maxc*img.img.y[j,i]/img.maxy));
			  writebuf(dpng,8*j*(bpsl+1)+(2*i+1)*bitd+8,bitd,round(maxc*img.img.a[j,i]/img.maxa));
		    end;
		end;
      end;
    end;
    dpng.sizeused:=dpng.sizetotal;
    dpng:=encodedef(dpng,true);
    if dpng.valid then
    begin
      chl:=dpng.sizeused+12;
      getmem(chd,chl);
      for i:=0 to chl-13 do byte((chd+8+i)^):=byte((dpng.data+i)^);
      write4byte(0,chl-12);
      writechunktype(4,'IDAT');
      write4byte(chl-4,crc);
      blockwrite(pngf,chd^,chl);
      freemem(chd,chl);
      donebuf(dpng);
    end;
	
    {Chunk IEND}
    chl:=0+12;
    getmem(chd,chl);
    write4byte(0,chl-12);
    writechunktype(4,'IEND');
    write4byte(chl-4,crc);
    blockwrite(pngf,chd^,chl);
	freemem(chd,chl);
    close(pngf);
  end
  else
  begin
	writeln('pngdump: maximum index or component bit depth exceeded ... trying true color');
	pngdump(idx2tru(img),pngs);
  end;
end;

function pngload(pngs:string):timage;
const
  starting_row:array[0..7] of  longint=(0,0,0,4,0,2,0,1);
  starting_col:array[0..7] of  longint=(0,0,4,0,2,0,1,0);
  row_increment:array[0..7] of longint=(1,8,8,8,4,4,2,2);
  col_increment:array[0..7] of longint=(1,8,8,4,4,2,2,1);
var pngf:file;
    img:timage;
    filesig:array[0..7] of byte;
    cht:string;
    chl,crc:longint;
    chd:pointer;
    pngcoltype,pngbitdepth,cmethod,fmethod,imethod:byte;
    i,j:longint;
    done:boolean;
    ftype:byte;
    bitperpxl,bytesperpxl,bpsl,bitsl:longint;
    pass:byte;
    tmpd,tmpdp:pointer;
	imgd:tbuf;
    dpng:tbuf;
    ppng,imgp:longint;
	cky,ckr,ckg,ckb:word;
function read1byte:byte;
var b:byte;
begin
  blockread(pngf,b,1);
  read1byte:=b;
end;
function read2byte:longint;
var b:array[0..1] of byte;
    x:array[0..1] of longint;
    i:longint;
begin
  blockread(pngf,b,2);
  for i:=0 to 1 do x[i]:=b[i];
  read2byte:=256*x[0]+x[1];
end;
function read4byte:longint;
var b:array[0..3] of byte;
    x:array[0..3] of longint;
    i:longint;
begin
  blockread(pngf,b,4);
  for i:=0 to 3 do x[i]:=b[i];
  read4byte:=256*(256*(256*x[0]+x[1])+x[2])+x[3];
end;
function readchunc:string;
var c:array[0..3] of char;
begin
  blockread(pngf,c,4);
  readchunc:=c[0]+c[1]+c[2]+c[3];
end;
function pp(a,b,c:longint):byte;
var p,pa,pb,pc:longint;
begin
  p:=a+b-c;
  pa:=abs(p-a);
  pb:=abs(p-b);
  pc:=abs(p-c);
  if (pa<=pb) and (pa<=pc) then pp:=a
  else
  begin
    if pb<=pc then pp:=b else pp:=c;
  end;
end;
function getspecbyte(tmp:pointer;i:longint):byte;
begin
  if i>=0 then getspecbyte:=byte((tmp+i)^) else getspecbyte:=0;
end;
procedure setbit(b:longint;v:boolean);
begin
  if b<8*img.sy*bpsl then
  begin
    if v
    then byte((imgd.data+b div 8)^):=byte((imgd.data+b div 8)^) or (128 shr (b mod 8))
    else byte((imgd.data+b div 8)^):=byte((imgd.data+b div 8)^) and (255-(128 shr (b mod 8)));
  end;
end;
function getbit(b:longint):boolean;
begin
  if b<8*img.sy*bpsl
    then getbit:=(byte((tmpd+b div 8)^) and (128 shr (b mod 8))>0)
    else getbit:=false;
end;
function getvalue(var b:longint):word;
var k:byte;
	w:word;
begin
  w:=0;
  for k:=0 to pngbitdepth-1 do if b<8*img.sy*bpsl then 
  begin
    w:=w shl 1+byte(byte((imgd.data+b div 8)^) and (128 shr (b mod 8))>0);
	inc(b);
  end;
  getvalue:=w;
end;
begin
  img:=resetimg;
  assign(pngf,pngs);
  reset(pngf,1);
  if ioresult=0 then
  begin
    dpng:=initbuf(filesize(pngf));
    blockread(pngf,filesig,8);
    repeat
      chl:=read4byte;
      cht:=readchunc;
//      writeln(cht,' ',chl);
      done:=false;
      if cht='IHDR' then
      begin
        img.sx:=read4byte;
        img.sy:=read4byte;
        pngbitdepth:=read1byte;
        pngcoltype:=read1byte;
        case pngcoltype of
        0: 
		  begin
		    img.imgtype:=tru;
			img.coltype:=y;
			setlength(img.img.y,img.sy,img.sx);
			img.leni:=0;
			img.maxy:=(1 shl pngbitdepth)-1;
			bitperpxl:=1*pngbitdepth;
		  end;
        2: 
		  begin
		    img.imgtype:=tru;
			img.coltype:=rgb;
			setlength(img.img.r,img.sy,img.sx);
			setlength(img.img.g,img.sy,img.sx);
			setlength(img.img.b,img.sy,img.sx);
			img.leni:=0;
		    img.maxr:=(1 shl pngbitdepth)-1;
			img.maxg:=(1 shl pngbitdepth)-1;
			img.maxb:=(1 shl pngbitdepth)-1;
			bitperpxl:=3*pngbitdepth;
		  end;
        3: 
		  begin
		    img.imgtype:=idx;
			img.coltype:=rgb;
			setlength(img.img.i,img.sy,img.sx);
			img.leni:=1 shl pngbitdepth;
			setlength(img.pal.r,img.leni);
			setlength(img.pal.g,img.leni);
			setlength(img.pal.b,img.leni);
		    img.maxr:=255;
			img.maxg:=255;
			img.maxb:=255;
			for i:=0 to img.leni-1 do
            begin
              img.pal.r[i]:=0;
              img.pal.g[i]:=0;
              img.pal.b[i]:=0;
			end;
			bitperpxl:=1*pngbitdepth;
		  end;
        4: 
		  begin
		    img.imgtype:=tru;
			img.coltype:=ya;
			setlength(img.img.y,img.sy,img.sx);
			setlength(img.img.a,img.sy,img.sx);
			img.leni:=0;
		    img.maxy:=(1 shl pngbitdepth)-1;
			img.maxa:=(1 shl pngbitdepth)-1;
			bitperpxl:=2*pngbitdepth;
		  end;
        6: 
		  begin
		    img.imgtype:=tru;
			img.coltype:=rgba;
			setlength(img.img.r,img.sy,img.sx);
			setlength(img.img.g,img.sy,img.sx);
			setlength(img.img.b,img.sy,img.sx);
			setlength(img.img.a,img.sy,img.sx);
			img.leni:=0;
		    img.maxr:=(1 shl pngbitdepth)-1;
			img.maxg:=(1 shl pngbitdepth)-1;
			img.maxb:=(1 shl pngbitdepth)-1;
			img.maxa:=(1 shl pngbitdepth)-1;
			bitperpxl:=4*pngbitdepth;
		  end;
        end;
        bytesperpxl:=(bitperpxl+7) div 8;
        cmethod:=read1byte;
		cmethod:=cmethod;
        fmethod:=read1byte;
		fmethod:=fmethod;
        imethod:=read1byte;
        done:=true;
      end;
      if cht='PLTE' then
      begin
        for i:=0 to chl div 3-1 do
        begin
		  img.pal.r[i]:=read1byte;
		  img.pal.g[i]:=read1byte;
		  img.pal.b[i]:=read1byte;
        end;
        done:=true;
      end;
      if cht='tRNS' then
      begin
        case pngcoltype of
        3: begin
             img.coltype:=rgba;
			 setlength(img.pal.a,img.leni);
			 img.maxa:=255;
			 for i:=0 to img.leni-1 do img.pal.a[i]:=255;
             for i:=0 to chl-1 do img.pal.a[i]:=read1byte;
             done:=true;
           end;
        0: begin
             cky:=read2byte;
             img.coltype:=ya;
			 setlength(img.img.a,img.sy,img.sx);
			 img.maxa:=1;
			 for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do img.img.a[j,i]:=byte(img.img.y[j,i]<>cky);
             done:=true;
           end;
        2: begin
             ckr:=read2byte;
             ckg:=read2byte;
             ckb:=read2byte;
             img.coltype:=rgba;
			 setlength(img.img.a,img.sy,img.sx);
			 img.maxa:=1;
			 for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do img.img.a[j,i]:=byte((img.img.r[j,i]<>ckr) or (img.img.g[j,i]<>ckg) or (img.img.b[j,i]<>ckb));
             done:=true;
           end;
        end;
      end;
      if cht='IDAT' then
      begin
        if chl>0 then
        begin
          blockread(pngf,(dpng.data+dpng.sizeused)^,chl);
          inc(dpng.sizeused,chl);
        end;
        done:=true;
      end;
      if not done and (chl>0) then
      begin
        getmem(chd,chl);
        blockread(pngf,chd^,chl);
        freemem(chd,chl);
      end;
      crc:=read4byte;
	  crc:=crc;
    until eof(pngf) or (cht='IEND');
    close(pngf);
    dpng:=decodedef(dpng,true);

    if dpng.valid then
    begin
      ppng:=0;
      bpsl:=(img.sx*bitperpxl+7) div 8;
      imgd:=initbuf(img.sy*bpsl);
      for pass:=1*imethod to 7*imethod do
      begin
        bitsl:=(((img.sx-starting_col[pass]+col_increment[pass]-1) div col_increment[pass])*bitperpxl+7) div 8;
        if bitsl>0 then
        begin
          getmem(tmpd,bitsl);
          getmem(tmpdp,bitsl);
          for i:=0 to bitsl-1 do byte((tmpdp+i)^):=0;
          for i:=0 to (img.sy-starting_row[pass]+row_increment[pass]-1) div row_increment[pass]-1 do
          begin
            ftype:=byte((dpng.data+ppng)^);
            inc(ppng);
            for j:=0 to bitsl-1 do byte((tmpd+j)^):=byte((dpng.data+ppng+j)^);
            inc(ppng,bitsl);
            for j:=0 to bitsl-1 do
            begin
              case ftype of
              0: ;
              1: inc(byte((tmpd+j)^),getspecbyte(tmpd,j-bytesperpxl));
              2: inc(byte((tmpd+j)^),byte((tmpdp+j)^));
              3: inc(byte((tmpd+j)^),(byte((tmpdp+j)^)+getspecbyte(tmpd,j-bytesperpxl)) div 2);
              4: inc(byte((tmpd+j)^),pp(getspecbyte(tmpd,j-bytesperpxl),
                   byte((tmpdp+j)^),getspecbyte(tmpdp,j-bytesperpxl)));
              end;
            end;
            for j:=0 to bitsl-1 do byte((tmpdp+j)^):=byte((tmpd+j)^);
            for j:=0 to 8*bitsl-1 do
              setbit(8*(starting_row[pass]+i*row_increment[pass])*bpsl
                +bitperpxl*(starting_col[pass]+(j div bitperpxl)*col_increment[pass])+j mod bitperpxl,getbit(j));
          end;
          freemem(tmpd,bitsl);
          freemem(tmpdp,bitsl);
        end;
      end;
      donebuf(dpng);
      for j:=0 to img.sy-1 do 
	  begin
	    imgp:=j*8*bpsl;
	    for i:=0 to img.sx-1 do
	    begin
          case pngcoltype of
          0: 
			  img.img.y[j,i]:=getvalue(imgp);
          2: 
		    begin
			  img.img.r[j,i]:=getvalue(imgp);
			  img.img.g[j,i]:=getvalue(imgp);
			  img.img.b[j,i]:=getvalue(imgp);
			end;
          3: 
			  img.img.i[j,i]:=getvalue(imgp);
          4: 
		    begin
			  img.img.y[j,i]:=getvalue(imgp);
			  img.img.a[j,i]:=getvalue(imgp);
			end;
		  6:
		    begin
			  img.img.r[j,i]:=getvalue(imgp);
			  img.img.g[j,i]:=getvalue(imgp);
			  img.img.b[j,i]:=getvalue(imgp);
			  img.img.a[j,i]:=getvalue(imgp);
			end;
          end;
		end;	    
	  end;
      donebuf(imgd);
    end
    else writeln('pngload: unknown png format in '+pngs);
  end
  else writeln('pngload: file '+pngs+' not found');
  pngload:=img;
end;

procedure pdfdump(img:timage;pdfs:string);
var pdff:file;
    xrefs:array[1..20] of longint;
    lengthref,xrefref,n:longint;
    palbuf,conbuf,trabuf:tbuf;
	bipcrgby,bipca,bipci:byte;
    i,j:longint;
	fscnt:longint;
procedure twritex(var f:file;s:string);
begin
  inc(fscnt,length(s));
  blockwrite(f,s[1],byte(s[0]));
end;
procedure blockwritex(var f:file;var v;n:longint);
begin
  inc(fscnt,n);
  blockwrite(f,v,n);
end;
function strfi(i:longint):string;
var si:string;
begin
  si:='';
  str(i,si);
  strfi:=si;
end;
function strfi10(i:longint):string;
var si:string;
begin
  si:='';
  str(i,si);
  while length(si)<10 do si:='0'+si;
  strfi10:=si;
end;
procedure upxrefs(var n:longint);
begin
  inc(n);
  xrefs[n]:=fscnt;
end;
function hex(b:word):string;
begin
  hex:=chr(b div 16+ord('0')*word(b div 16<=9)+(ord('A')-10)*word(b div 16>9))
    +chr(b mod 16+ord('0')*word(b mod 16<=9)+(ord('A')-10)*word(b mod 16>9));
end;
begin
  if (img.imgtype=tru) or ((img.imgtype=idx) and (img.leni<=256) and (((img.coltype in [rgb,rgba]) and (img.maxr<256) and (img.maxg<256) and (img.maxb<256)) 
	or ((img.coltype in [y,ya]) and (img.maxy<256)))) then
  begin
	if img.imgtype=idx then
	begin
	  case img.coltype of
	  y,ya: 
		begin
		  bipcrgby:=8+8*byte(img.maxy>255);
		  palbuf:=initbuf((img.leni*bipcrgby-1) div 8+1);
		  for i:=0 to img.leni-1 do writebuf(palbuf,i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.y[i]/img.maxy));
		  palbuf.sizeused:=(img.leni*bipcrgby-1) div 8+1;
		end;
	  rgb,rgba:
		begin
		  bipcrgby:=8+8*byte((img.maxr>255) or (img.maxg>255) or (img.maxb>255));
		  palbuf:=initbuf((3*img.leni*bipcrgby-1) div 8+1);
		  for i:=0 to img.leni-1 do 
		  begin
			writebuf(palbuf,3*i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.r[i]/img.maxr));
			writebuf(palbuf,(3*i+1)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.g[i]/img.maxg));
			writebuf(palbuf,(3*i+2)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.b[i]/img.maxb));
		  end;
		  palbuf.sizeused:=(3*img.leni*bipcrgby-1) div 8+1;
		end;
	  end;
	  palbuf:=encodea85(encodedef(palbuf,true),true);
	end;
  
	if img.coltype in [ya,rgba] then
	begin
	  bipca:=8+8*byte(img.maxa>255);
	  trabuf:=initbuf(img.sy*((img.sx*bipca-1) div 8+1));
	  for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
		case img.imgtype of
		idx: writebuf(trabuf,8*j*((img.sx*bipca-1) div 8+1)+i*bipca,bipca,round((1 shl bipca-1)*img.pal.a[img.img.i[j,i]]/img.maxa));
		tru: writebuf(trabuf,8*j*((img.sx*bipca-1) div 8+1)+i*bipca,bipca,round((1 shl bipca-1)*img.img.a[j,i]/img.maxa));
		end;
	  trabuf.sizeused:=img.sy*((img.sx*bipca-1) div 8+1);
	  trabuf:=encodea85(encodedef(trabuf,true),true);
	end;

	case img.imgtype of
	idx: begin
		   bipci:=8+8*byte(img.leni>256);
		   conbuf:=initbuf(img.sy*((img.sx*bipci-1) div 8+1));
		   for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
			 writebuf(conbuf,8*j*((img.sx*bipci-1) div 8+1)+i*bipci,bipci,img.img.i[j,i]);
		   conbuf.sizeused:=img.sy*((img.sx*bipci-1) div 8+1);
		 end;
	tru: case img.coltype of
		 y,ya:  
		   begin
			 bipcrgby:=8+8*byte(img.maxy>255);
			 conbuf:=initbuf(img.sy*((img.sx*bipcrgby-1) div 8+1));
			 for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
			   writebuf(conbuf,8*j*((img.sx*bipcrgby-1) div 8+1)+i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.y[j,i]/img.maxy));
			 conbuf.sizeused:=img.sy*((img.sx*bipcrgby-1) div 8+1);
		   end;
		 rgb,rgba:
		   begin
			 bipcrgby:=8+8*byte((img.maxr>255) or (img.maxg>255) or (img.maxb>255));
			 conbuf:=initbuf(img.sy*((3*img.sx*bipcrgby-1) div 8+1));
			 for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
			 begin
			   writebuf(conbuf,8*j*((3*img.sx*bipcrgby-1) div 8+1)+3*i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.r[j,i]/img.maxr));
			   writebuf(conbuf,8*j*((3*img.sx*bipcrgby-1) div 8+1)+(3*i+1)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.g[j,i]/img.maxg));
			   writebuf(conbuf,8*j*((3*img.sx*bipcrgby-1) div 8+1)+(3*i+2)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.b[j,i]/img.maxb));
			 end;
			 conbuf.sizeused:=img.sy*((3*img.sx*bipcrgby-1) div 8+1);
		   end;
	     end;
	end;
	conbuf:=encodea85(encodedef(conbuf,true),true);

    assign(pdff,pdfs);
    rewrite(pdff,1);
    fscnt:=0;
    n:=0;
    if img.coltype in [ya,rgba] then twritex(pdff,'%PDF-1.4'+#$0a) else twritex(pdff,'%PDF-1.1'+#$0a);
    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/Type /Catalog'+#$0a);
    twritex(pdff,'/Pages '+strfi(n+2)+' 0 R'+#$0a);
    twritex(pdff,'/Outlines '+strfi(n+1)+' 0 R'+#$0a);
    twritex(pdff,'>>'+#$0a);
    twritex(pdff,'endobj'+#$0a);
    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/Type /Outlines'+#$0a);
    twritex(pdff,'/Count 0'+#$0a);
    twritex(pdff,'>>'+#$0a);
    twritex(pdff,'endobj'+#$0a);
    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/Type /Pages'+#$0a);
    twritex(pdff,'/Count 1'+#$0a);
    twritex(pdff,'/Kids ['+strfi(n+1)+' 0 R]'+#$0a);
    twritex(pdff,'/MediaBox [0 0 '+strfi(img.sx)+' '+strfi(img.sy)+']'+#$0a);
    twritex(pdff,'>>'+#$0a);
    twritex(pdff,'endobj'+#$0a);
    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/Type /Page'+#$0a);
    twritex(pdff,'/Parent '+strfi(n-1)+' 0 R'+#$0a);
    twritex(pdff,'/Resources'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/ProcSet [/PDF ');
    if img.imgtype=idx then twritex(pdff,'/ImageI ');
    case img.coltype of
    y,ya:     twritex(pdff,'/ImageB]'+#$0a);
    rgb,rgba: twritex(pdff,'/ImageC]'+#$0a);
    end;
    twritex(pdff,'/XObject << /Im1 '+strfi(n+3)+' 0 R >>'+#$0a);
    twritex(pdff,'>>'+#$0a);
    twritex(pdff,'/Rotate 0'+#$0a);
    twritex(pdff,'/MediaBox [0 0 '+strfi(img.sx)+' '+strfi(img.sy)+']'+#$0a);
    twritex(pdff,'/Contents '+strfi(n+1)+' 0 R'+#$0a);
    twritex(pdff,'>>'+#$0a);
    twritex(pdff,'endobj'+#$0a);

    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/Length '+strfi(n+1)+' 0 R'+#$0a);
    twritex(pdff,'>>'+#$0a);
    twritex(pdff,'stream'+#$0a);
    lengthref:=fscnt;
    twritex(pdff,'q'+#$0a);
    twritex(pdff,strfi(img.sx)+' 0 0 '+strfi(img.sy)+' 0 0 cm'+#$0a);
    twritex(pdff,'/Im1 Do'+#$0a);
    twritex(pdff,'Q '+#$0a);

    lengthref:=fscnt-lengthref;
    twritex(pdff,'endstream'+#$0a);
    twritex(pdff,'endobj'+#$0a);
    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,strfi(lengthref)+#$0a);
    twritex(pdff,'endobj'+#$0a);

    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/Type /XObject'+#$0a);
    twritex(pdff,'/Subtype /Image'+#$0a);
    twritex(pdff,'/Name /Im1'+#$0a);
    twritex(pdff,'/Width '+strfi(img.sx)+#$0a);
    twritex(pdff,'/Height '+strfi(img.sy)+#$0a);
    case img.imgtype of
    idx: twritex(pdff,'/BitsPerComponent '+strfi(bipci)+#$0a);
    tru: twritex(pdff,'/BitsPerComponent '+strfi(bipcrgby)+#$0a);
    end;
    twritex(pdff,'/ColorSpace ');
    if img.imgtype=idx then twritex(pdff,'[/Indexed ');
    case img.coltype of
    y,ya:     twritex(pdff,'/DeviceGray');
    rgb,rgba: twritex(pdff,'/DeviceRGB');
    end;
    if img.imgtype=idx then twritex(pdff,' '+strfi(img.leni-1)+' '+strfi(n+2)+' 0 R]');
    twritex(pdff,#$0a);
    if img.coltype in [ya,rgba] then
    begin
      case img.imgtype of
      idx: twritex(pdff,'/SMask '+strfi(n+4)+' 0 R'+#$0a);
      tru: twritex(pdff,'/SMask '+strfi(n+2)+' 0 R'+#$0a);
      end;
    end;
    twritex(pdff,'/Length '+strfi(n+1)+' 0 R'+#$0a);
    if conbuf.valid then
    begin
      twritex(pdff,'/Filter [/ASCII85Decode /FlateDecode]'+#$0a+'>>'+#$0a+'stream'+#$0a);
      lengthref:=fscnt;
      blockwritex(pdff,conbuf.data^,conbuf.sizeused);
      donebuf(conbuf);
      twritex(pdff,#$0a);
    end;
    lengthref:=fscnt-lengthref;
    twritex(pdff,'endstream'+#$0a);
    twritex(pdff,'endobj'+#$0a);
    upxrefs(n);
    twritex(pdff,strfi(n)+' 0 obj'+#$0a);
    twritex(pdff,strfi(lengthref)+#$0a);
    twritex(pdff,'endobj'+#$0a);

    if img.imgtype=idx then
    begin
      upxrefs(n);
      twritex(pdff,strfi(n)+' 0 obj'+#$0a);
      twritex(pdff,'<<'+#$0a);
      twritex(pdff,'/BitsPerComponent '+strfi(bipcrgby)+#$0a);
      twritex(pdff,'/Length '+strfi(n+1)+' 0 R'+#$0a);
      if palbuf.valid then
      begin
        twritex(pdff,'/Filter [/ASCII85Decode /FlateDecode] '+#$0a+'>>'+#$0a+'stream'+#$0a);
        lengthref:=fscnt;
        blockwritex(pdff,palbuf.data^,palbuf.sizeused);
        donebuf(palbuf);
      end;
      twritex(pdff,#$0a);
      lengthref:=fscnt-lengthref;
      twritex(pdff,'endstream'+#$0a);
      twritex(pdff,'endobj'+#$0a);
      upxrefs(n);
      twritex(pdff,strfi(n)+' 0 obj'+#$0a);
      twritex(pdff,strfi(lengthref)+#$0a);
      twritex(pdff,'endobj'+#$0a);
    end;

    if img.coltype in [ya,rgba] then
    begin
      upxrefs(n);
      twritex(pdff,strfi(n)+' 0 obj'+#$0a);
      twritex(pdff,'<<'+#$0a);
      twritex(pdff,'/Type /XObject'+#$0a);
      twritex(pdff,'/Subtype /Image'+#$0a);
      twritex(pdff,'/Width '+strfi(img.sx)+#$0a);
      twritex(pdff,'/Height '+strfi(img.sy)+#$0a);
      twritex(pdff,'/BitsPerComponent '+strfi(bipca)+#$0a);
      twritex(pdff,'/ColorSpace /DeviceGray'+#$0a);
      twritex(pdff,'/Length '+strfi(n+1)+' 0 R'+#$0a);
      if trabuf.valid then
      begin
        twritex(pdff,'/Filter [/ASCII85Decode /FlateDecode]'+#$0a+'>>'+#$0a+'stream'+#$0a);
        lengthref:=fscnt;
        blockwritex(pdff,trabuf.data^,trabuf.sizeused);
        donebuf(trabuf);
        twritex(pdff,#$0a);
      end;
      lengthref:=fscnt-lengthref;
      twritex(pdff,'endstream'+#$0a);
      twritex(pdff,'endobj'+#$0a);
      upxrefs(n);
      twritex(pdff,strfi(n)+' 0 obj'+#$0a);
      twritex(pdff,strfi(lengthref)+#$0a);
      twritex(pdff,'endobj'+#$0a);
    end;

    xrefref:=fscnt;
    twritex(pdff,'xref'+#$0a);
    twritex(pdff,'0 '+strfi(n+1)+#$0a);
    twritex(pdff,'0000000000 65535 f '+#$0a);
    for i:=1 to n do twritex(pdff,strfi10(xrefs[i])+' 00000 n '+#$0a);
    twritex(pdff,'trailer'+#$0a);
    twritex(pdff,'<<'+#$0a);
    twritex(pdff,'/Size '+strfi(n+1)+#$0a);
    twritex(pdff,'/Root 1 0 R'+#$0a);
    twritex(pdff,'>>'+#$0a);
    twritex(pdff,'startxref'+#$0a);
    twritex(pdff,strfi(xrefref)+#$0a);
    twritex(pdff,'%%EOF'+#$0a);
    close(pdff);
  end
  else
  begin
	writeln('pdfdump: maximum index or color bit depth exceeded ... trying true color');
	pdfdump(idx2tru(img),pdfs);
  end;
end;

procedure epsdump(img:timage;epss:string);
var epsf:file;
    palbuf,conbuf:tbuf;
	bipcrgby,bipci:byte;
	i,j:longint;
	tf1buf,tf2buf:array of word;
	tfidx,tfmin,tfmax:word;
procedure twrite(var f:file;s:string);
begin
  blockwrite(f,s[1],byte(s[0]));
end;
function strfi(i:longint):string;
var si:string;
begin
  si:='';
  str(i,si);
  strfi:=si;
end;
function strfi10(i:longint):string;
var si:string;
begin
  si:='';
  str(i,si);
  while length(si)<10 do si:='0'+si;
  strfi10:=si;
end;
function hex(b:word):string;
begin
  hex:=chr(b div 16+ord('0')*word(b div 16<=9)+(ord('A')-10)*word(b div 16>9))
    +chr(b mod 16+ord('0')*word(b mod 16<=9)+(ord('A')-10)*word(b mod 16>9));
end;
begin
  if ((img.coltype in [rgb,rgba]) and (img.maxr<4096) and (img.maxg<4096) and (img.maxb<4096)) 
	or ((img.coltype in [y,ya]) and (img.maxy<4096)) then
  begin
    if (img.coltype in [rgb,y]) or ((img.coltype in [rgba,ya]) and (img.maxa<2)) then
    begin
      if (img.imgtype=tru) or ((img.imgtype=idx) and (img.leni<=4096)) then
	  begin

        if img.imgtype=idx then
		begin
		  setlength(tf1buf,img.leni);
		  setlength(tf2buf,img.leni);
		  case img.coltype of
		  y,rgb:   
		    begin
			  for i:=0 to img.leni-1 do tf1buf[i]:=i;
			  for i:=0 to img.leni-1 do tf2buf[i]:=i;
			end;
		  ya,rgba: 
		    begin
			  tfidx:=0;
			  tfmin:=0;
			  for i:=0 to img.leni-1 do if img.pal.a[i]=0 then 
			  begin
			    tf1buf[tfidx]:=i;
			    tf2buf[i]:=tfidx;
				tfmax:=tfidx;
				inc(tfidx);
			  end;
			  for i:=0 to img.leni-1 do if img.pal.a[i]>0 then 
			  begin
			    tf1buf[tfidx]:=i;
			    tf2buf[i]:=tfidx;
				inc(tfidx);
			  end;
			end;
		  end;
		  
		  case img.coltype of
          y,ya: 
	        begin
	          bipcrgby:=8+4*byte(img.maxy>255);
		      palbuf:=initbuf((img.leni*bipcrgby-1) div 8+1);
		      for i:=0 to img.leni-1 do writebuf(palbuf,i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.y[tf1buf[i]]/img.maxy));
		      palbuf.sizeused:=(img.leni*bipcrgby-1) div 8+1;
	        end;
          rgb,rgba:
	        begin
	          bipcrgby:=8+4*byte((img.maxr>255) or (img.maxg>255) or (img.maxb>255));
		      palbuf:=initbuf((3*img.leni*bipcrgby-1) div 8+1);
		      for i:=0 to img.leni-1 do 
			  begin
			    writebuf(palbuf,3*i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.r[tf1buf[i]]/img.maxr));
			    writebuf(palbuf,(3*i+1)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.g[tf1buf[i]]/img.maxg));
			    writebuf(palbuf,(3*i+2)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.pal.b[tf1buf[i]]/img.maxb));
		      end;
			  palbuf.sizeused:=(3*img.leni*bipcrgby-1) div 8+1;
	        end;
          end;
          palbuf:=encodea85(palbuf,true);
        end;
  
        case img.imgtype of
        idx: begin
	           bipci:=8+4*byte(img.leni>256);
			   conbuf:=initbuf(img.sy*((img.sx*bipci-1) div 8+1));
			   for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
                 writebuf(conbuf,8*j*((img.sx*bipci-1) div 8+1)+i*bipci,bipci,tf2buf[img.img.i[j,i]]);
			   conbuf.sizeused:=img.sy*((img.sx*bipci-1) div 8+1);
             end;
        tru: case img.coltype of
             y:  
	           begin
	             bipcrgby:=8+4*byte(img.maxy>255);
			     conbuf:=initbuf(img.sy*((img.sx*bipcrgby-1) div 8+1));
			     for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
                   writebuf(conbuf,8*j*((img.sx*bipcrgby-1) div 8+1)+i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.y[j,i]/img.maxy));
			     conbuf.sizeused:=img.sy*((img.sx*bipcrgby-1) div 8+1);
		       end;
             ya:  
	           begin
	             bipcrgby:=8+4*byte(img.maxy>255);
			     conbuf:=initbuf(img.sy*((2*img.sx*bipcrgby-1) div 8+1));
			     for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
				 begin
                   writebuf(conbuf,8*j*((2*img.sx*bipcrgby-1) div 8+1)+2*i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*(1-img.img.a[j,i]/img.maxa)));
                   writebuf(conbuf,8*j*((2*img.sx*bipcrgby-1) div 8+1)+(2*i+1)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.y[j,i]/img.maxy));
			     end;
				 conbuf.sizeused:=img.sy*((2*img.sx*bipcrgby-1) div 8+1);
		       end;
		     rgb:
	           begin
				 bipcrgby:=8+4*byte((img.maxr>255) or (img.maxg>255) or (img.maxb>255));
			     conbuf:=initbuf(img.sy*((3*img.sx*bipcrgby-1) div 8+1));
			     for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
				 begin
                   writebuf(conbuf,8*j*((3*img.sx*bipcrgby-1) div 8+1)+3*i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.r[j,i]/img.maxr));
                   writebuf(conbuf,8*j*((3*img.sx*bipcrgby-1) div 8+1)+(3*i+1)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.g[j,i]/img.maxg));
                   writebuf(conbuf,8*j*((3*img.sx*bipcrgby-1) div 8+1)+(3*i+2)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.b[j,i]/img.maxb));
				 end;
			     conbuf.sizeused:=img.sy*((3*img.sx*bipcrgby-1) div 8+1);
		       end;
		     rgba:
	           begin
				 bipcrgby:=8+4*byte((img.maxr>255) or (img.maxg>255) or (img.maxb>255));
			     conbuf:=initbuf(img.sy*((4*img.sx*bipcrgby-1) div 8+1));
			     for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
				 begin
                   writebuf(conbuf,8*j*((4*img.sx*bipcrgby-1) div 8+1)+4*i*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*(1-img.img.a[j,i]/img.maxa)));
                   writebuf(conbuf,8*j*((4*img.sx*bipcrgby-1) div 8+1)+(4*i+1)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.r[j,i]/img.maxr));
                   writebuf(conbuf,8*j*((4*img.sx*bipcrgby-1) div 8+1)+(4*i+2)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.g[j,i]/img.maxg));
                   writebuf(conbuf,8*j*((4*img.sx*bipcrgby-1) div 8+1)+(4*i+3)*bipcrgby,bipcrgby,round((1 shl bipcrgby-1)*img.img.b[j,i]/img.maxb));
				 end;
			     conbuf.sizeused:=img.sy*((4*img.sx*bipcrgby-1) div 8+1);
		       end;
             end;
		end;
        conbuf:=encodea85(encodedef(conbuf,true),true);

        assign(epsf,epss);
        rewrite(epsf,1);
        twrite(epsf,'%!PS-Adobe-3.0 EPSF-3.0'+#$0a);
        twrite(epsf,'%%BoundingBox: 0 0 '+strfi(img.sx)+' '+strfi(img.sy)+#$0a);
        twrite(epsf,'%%EndComments'+#$0a);
        twrite(epsf,'gsave'+#$0a);
        case img.imgtype of
        idx: if palbuf.valid then
             begin
               case img.coltype of
			   rgb,rgba: twrite(epsf,'[/Indexed /DeviceRGB '+strfi(1 shl bipci-1)+' <~'+#$0a);
			   y,ya:     twrite(epsf,'[/Indexed /DeviceGray '+strfi(1 shl bipci-1)+' <~'+#$0a);
			   end;
               blockwrite(epsf,palbuf.data^,palbuf.sizeused);
               donebuf(palbuf);
               twrite(epsf,#$0a+'] setcolorspace'+#$0a);
             end;
        tru: case img.coltype of
             y,ya:     twrite(epsf,'/DeviceGray setcolorspace'+#$0a);
             rgb,rgba: twrite(epsf,'/DeviceRGB setcolorspace'+#$0a);
             end;
        end;
        twrite(epsf,strfi(img.sx)+' '+strfi(img.sy)+' scale'+#$0a);
        if (img.imgtype=tru) and (img.coltype in [rgba,ya]) then
		begin
          twrite(epsf,'<<'+#$0a);
		  twrite(epsf,'/ImageType 3'+#$0a);
		  twrite(epsf,'/InterleaveType 1'+#$0a);
		  twrite(epsf,'/MaskDict'+#$0a);
          twrite(epsf,'<<'+#$0a);
		  twrite(epsf,'/ImageType 1'+#$0a);
          twrite(epsf,'/Width '+strfi(img.sx)+#$0a);
          twrite(epsf,'/Height '+strfi(img.sy)+#$0a);
		  twrite(epsf,'/BitsPerComponent '+strfi(bipcrgby)+#$0a);
		  twrite(epsf,'/Decode [0 1]'+#$0a);
          twrite(epsf,'/ImageMatrix ['+strfi(img.sx)+' 0 0 -'+strfi(img.sy)+' 0 '+strfi(img.sy)+']'+#$0a);
		  twrite(epsf,'>>'+#$0a);
		  twrite(epsf,'/DataDict'+#$0a);
        end;
        twrite(epsf,'<<'+#$0a);
		if (img.imgtype=idx) and (img.coltype in [ya,rgba]) then 
		begin
		  twrite(epsf,'/ImageType 4'+#$0a);
		  twrite(epsf,'/MaskColor ['+strfi(tfmin)+' '+strfi(tfmax)+']'+#$0a);
		end
		else twrite(epsf,'/ImageType 1'+#$0a);
        twrite(epsf,'/Width '+strfi(img.sx)+#$0a);
        twrite(epsf,'/Height '+strfi(img.sy)+#$0a);
        case img.imgtype of
        idx: begin
               twrite(epsf,'/BitsPerComponent '+strfi(bipci)+#$0a);
               twrite(epsf,'/Decode [0 '+strfi(1 shl bipci-1)+']'+#$0a);
             end;
        tru: begin
               twrite(epsf,'/BitsPerComponent '+strfi(bipcrgby)+#$0a);
               case img.coltype of
               y,ya:     twrite(epsf,'/Decode [0 1]'+#$0a);
               rgb,rgba: twrite(epsf,'/Decode [0 1 0 1 0 1]'+#$0a);
               end;
             end;
        end;
        twrite(epsf,'/ImageMatrix ['+strfi(img.sx)+' 0 0 -'+strfi(img.sy)+' 0 '+strfi(img.sy)+']'+#$0a);
		twrite(epsf,'/DataSource currentfile /ASCII85Decode filter /FlateDecode filter'+#$0a+'>>'+#$0a);

        if (img.imgtype=tru) and (img.coltype in [rgba,ya]) then twrite(epsf,'>>'+#$0a);

        if conbuf.valid then
        begin
          twrite(epsf,'image'+#$0a);
          blockwrite(epsf,conbuf.data^,conbuf.sizeused);
          donebuf(conbuf);
          twrite(epsf,#$0a);
        end;

        twrite(epsf,'showpage'#$0a);
        twrite(epsf,'grestore'#$0a);
        twrite(epsf,'%%EOF'#$0a);
        close(epsf);
      end
      else
      begin
		writeln('epsdump: index maximum exceeds bounds ... trying true color');
	    epsdump(idx2tru(img),epss);
      end;
    end
    else writeln('epsdump: maximum alpha bit depth exceeded');
  end
  else writeln('epsdump: maximum color bit depth exceeded');
end;

function gifload(gifs:string):timage;
type pcword=array[0..1] of byte;
var giff:file;
    header:array[0..5] of char;
    screend:record
      swd:pcword;
      sht:pcword;
      xid:byte;
      bak:byte;
      dum:byte;
      end;
    glocolmax:byte;
    glocolmap:array[0..255,0..2] of byte;
    loccolmax:byte;
    loccolmap:array[0..255,0..2] of byte;
    xid:char;
    imaged:record
      ilt:pcword;
      itp:pcword;
      iwd:pcword;
      iht:pcword;
      xid:byte;
      end;
    codesize:byte;
    i:longint;
    clrcode:word;
    endcode:word;
    dicbot:word;
    dictop:word;
    dicbuf:tbuf;
    dicptr:array[0..4098] of longint;
    bt,cs:byte;
    ix,iy:word;
    vl:integer;
    blkcnt:byte;
    blkdat:array[1..255] of byte;
    gce:record
      bs:byte;
      id:byte;
      dt:pcword;
      tci:byte;
      bt:byte;
      end;
    pte:record
      bs:byte;
      tglp,tgtp,tgw,tgh:pcword;
      ccw,cch:byte;
      tfci,tbci:byte;
      end;
    ae:record
      bs:byte;
      ai:array[0..7] of byte;
      aac:array[0..2] of byte;
      end;
    interlaced:boolean;
	img:timage;
function getword(w:pcword):word;
begin
  getword:=256*w[1]+w[0];
end;
procedure setbeg(x:longint;i:longint);
begin
  dicptr[x]:=i;
end;
function getbeg(x:longint):longint;
begin
  getbeg:=dicptr[x];
end;
function getdic(x:longint):byte;
begin
  getdic:=byte((dicbuf.data+x)^);
end;
procedure setdic(x:longint;b:byte);
begin
  byte((dicbuf.data+x)^):=b;
end;
procedure initdic;
begin
  dicbuf:=initbuf(img.sy*img.sx);
  clrcode:=round(exp(codesize*ln(2)));
  endcode:=round(exp(codesize*ln(2))+1);
  dicbot:=round(exp(codesize*ln(2))+2);
  dictop:=dicbot;
  cs:=codesize;
  setbeg(dicbot,0);
  setbeg(dicbot+1,0);
end;
procedure donedic;
begin
  donebuf(dicbuf);
end;
function gety(iy:longint):longint;
begin
  if not interlaced then gety:=iy
  else
  begin
    if 8*iy<img.sy then gety:=8*iy
    else
    begin
      if 8*(iy-(img.sy+7) div 8)+4<img.sy then gety:=8*(iy-(img.sy+7) div 8)+4
      else
      begin
        if 4*(iy-(img.sy+3) div 4)+2<img.sy then gety:=4*(iy-(img.sy+3) div 4)+2
                                    else gety:=2*(iy-(img.sy+1) div 2)+1
      end;
    end;
  end;
end;
procedure xpixel(col:byte);
begin
  setdic(getbeg(dictop+1),col);
  setbeg(dictop+1,getbeg(dictop+1)+1);
  img.img.i[gety(iy),ix]:=col;
  inc(ix);
  if ix>=getword(imaged.iwd) then
  begin
    ix:=0;
    inc(iy);
  end;
end;
procedure xinteger(i:integer);
var j:longint;
begin
  if i=clrcode then
  begin
    donedic;
    initdic;
  end
  else
  begin
    if i=endcode then
    else
    begin
      if i<dicbot then xpixel(i);
      if (i>=dicbot) then for j:=getbeg(i) to getbeg(i+1) do xpixel(getdic(j));
      inc(dictop);
      setbeg(dictop+1,getbeg(dictop));
      if (dictop>round(exp((cs+1)*ln(2)))) then inc(cs);
      if cs>11 then cs:=11;
    end;
  end;
end;
procedure xbyte(b:byte);
var i:integer;
    bb:byte;
begin
  bb:=b;
  for i:=0 to 7 do
  begin
    vl:=vl+((integer(bb) mod 2) shl bt);
    bb:=bb div 2;
    inc(bt);
    if bt>cs then
    begin
      xinteger(vl);
      bt:=0;
      vl:=0;
    end;
  end;
end;
procedure xbild;
var i:integer;
begin
  if boolean(screend.xid div 128) then
  begin
	img.leni:=glocolmax+1;
	setlength(img.pal.r,img.leni);
	setlength(img.pal.g,img.leni);
	setlength(img.pal.b,img.leni);
    for i:=0 to glocolmax do
    begin
	  img.pal.r[i]:=glocolmap[i,0];
	  img.pal.g[i]:=glocolmap[i,1];
	  img.pal.b[i]:=glocolmap[i,2];
    end;
  end;
  if boolean(imaged.xid div 128) then
  begin
	img.leni:=loccolmax+1;
	setlength(img.pal.r,img.leni);
	setlength(img.pal.g,img.leni);
	setlength(img.pal.b,img.leni);
    for i:=0 to loccolmax do
    begin
	  img.pal.r[i]:=loccolmap[i,0];
	  img.pal.g[i]:=loccolmap[i,1];
	  img.pal.b[i]:=loccolmap[i,2];
    end;
  end;

  initdic;
  ix:=0;
  iy:=0;
  bt:=0;
  vl:=0;
  repeat
    blockread(giff,blkcnt,1);
    if blkcnt>0 then
    begin
      blockread(giff,blkdat,blkcnt);
      for i:=1 to blkcnt do xbyte(blkdat[i]);
    end;
  until blkcnt=0;
  donedic;
end;
begin
  img:=resetimg;
  assign(giff,gifs);
  reset(giff,1);
  if ioresult=0 then
  begin
    img.imgtype:=idx;
    img.coltype:=rgb;
	img.maxr:=255;
	img.maxg:=255;
	img.maxb:=255;

    interlaced:=false;
    blockread(giff,header,6);
    blockread(giff,screend,7);

    if {M}boolean(screend.xid div 128) then
    begin
      glocolmax:=round(exp(((screend.xid div 16) mod 8+1)*ln(2)))-1;
      blockread(giff,glocolmap,3*(glocolmax+1));
    end;
    repeat
      blockread(giff,xid,1);
      case xid of
      '!':
      begin
        blockread(giff,xid,1);
        case xid of
        #249:
          blockread(giff,gce,sizeof(gce));
        #254:
          begin
            repeat
              blockread(giff,blkcnt,1);
              if blkcnt>0 then
              begin
                blockread(giff,blkdat,blkcnt);
                for i:=1 to blkcnt do xbyte(blkdat[i]);
              end;
            until blkcnt=0;
          end;
        #001:
          begin
            blockread(giff,pte,sizeof(pte));
            repeat
              blockread(giff,blkcnt,1);
              if blkcnt>0 then
              begin
                blockread(giff,blkdat,blkcnt);
                for i:=1 to blkcnt do xbyte(blkdat[i]);
              end;
            until blkcnt=0;
          end;
        #255:
          begin
            blockread(giff,ae,sizeof(ae));
            repeat
              blockread(giff,blkcnt,1);
              if blkcnt>0 then
              begin
                blockread(giff,blkdat,blkcnt);
                for i:=1 to blkcnt do xbyte(blkdat[i]);
              end;
            until blkcnt=0;
          end;
        end;
      end;
      ',':
      begin
        blockread(giff,imaged,9);
        interlaced:=boolean((imaged.xid div 64) mod 2);
        if {M}boolean(imaged.xid div 128) then
        begin
          loccolmax:=round(exp(((imaged.xid div 16) mod 8+1)*ln(2)))-1;
          blockread(giff,loccolmap,3*(loccolmax+1));
        end;
        blockread(giff,codesize,1);
        img.sx:=getword(imaged.iwd);
        img.sy:=getword(imaged.iht);
		setlength(img.img.i,img.sy,img.sx);
        xbild;
      end;
      ';':;
      else writeln('Unknown tag: ',xid);
      end;
    until eof(giff);
    close(giff);

    if boolean(gce.id and 1) then 
	begin
	  img.coltype:=rgba;
	  setlength(img.pal.a,img.leni);
	  img.maxa:=1;
	  for i:=0 to img.leni-1 do img.pal.a[i]:=byte(i<>gce.tci);
	end;
  end
  else writeln('gifload: file '+gifs+' not found');
  gifload:=img;
end;

function tgaload(tgas:string):timage;
type pcword=array[0..1] of byte;
     pclongword=array[0..3] of byte;
     ttgahead=record
       IDlength:byte;
       colmaptype:byte;
       imagetype:byte;
       colmapspec_fei:pcword;
       colmapspec_cml:pcword;
       colmapspec_cmes:byte;
       imagespec_xo:pcword;
       imagespec_yo:pcword;
       imagespec_iw:pcword;
       imagespec_ih:pcword;
       imagespec_pd:byte;
       imagespec_id:byte;
     end;
     ttgafoot=record
       eao:pclongword;
       ddo:pclongword;
       sign:array[0..15] of char;
     end;
     ttgacol=record
       r,g,b,y,a:byte;
       end;
var tgaf:file;
    tgad:pointer;
    tgahead:ttgahead;
    tgafoot:ttgafoot;
    tgacol:ttgacol;
    c:pclongword;
	i,j,k,px,py:longint;
    bypp:longint;
    b:byte;
    flipx,flipy:boolean;
    extrabits:byte;
    bipcrgb,bipcy,bipca:byte;
    tgaalpha:byte;
    tgaalphav:boolean;
	img:timage;
function getpcword(a:pcword):word;
begin
  getpcword:=256*a[1]+a[0];
end;
function getpclongword(a:pclongword):longint;
begin
  getpclongword:=((a[3]*256+a[2])*256+a[1])*256+a[0];
end;
procedure setpcword(var a:pcword;w:word);
begin
  a[1]:=w mod 256;
  w:=(w-a[1]) div 256;
  a[0]:=w mod 256;
end;
procedure setpclongword(var a:pclongword; w:longword);
begin
  a[3]:=w mod 256;
  w:=(w-a[3]) div 256;
  a[2]:=w mod 256;
  w:=(w-a[2]) div 256;
  a[1]:=w mod 256;
  w:=(w-a[1]) div 256;
  a[0]:=w mod 256;
end;
begin  
  img:=resetimg;
  assign(tgaf,tgas);
  reset(tgaf,1);
  if ioresult=0 then
  begin
    if filesize(tgaf)>=sizeof(tgahead)+26 then
    begin
      seek(tgaf,filesize(tgaf)-26);
      blockread(tgaf,tgafoot,sizeof(tgafoot));
      if (tgafoot.sign='TRUEVISION-XFILE') and (getpclongword(tgafoot.eao)>0) then
      begin
        seek(tgaf,getpclongword(tgafoot.eao)+494);
        blockread(tgaf,tgaalpha,1);
        tgaalphav:=true;
      end else tgaalphav:=false;
    end else tgaalphav:=false;
    seek(tgaf,0);
    blockread(tgaf,tgahead,sizeof(tgahead));
    extrabits:=tgahead.imagespec_id and 15;
    if not tgaalphav and (extrabits>0) then
    begin
      tgaalphav:=true;
      tgaalpha:=3;
    end;
	tgaalphav:=tgaalphav and (extrabits>0);

    img.sx:=getpcword(tgahead.imagespec_iw);
    img.sy:=getpcword(tgahead.imagespec_ih);
    bypp:=((tgahead.imagespec_pd+7) div 8);
    case tgahead.imagetype of
      1,9:  begin
              img.imgtype:=idx;
			  setlength(img.img.i,img.sy,img.sx);
			  seek(tgaf,filepos(tgaf)+tgahead.IDlength);
              img.leni:=1 shl tgahead.imagespec_pd;
			  bipcrgb:=(tgahead.colmapspec_cmes-extrabits) div 3;
              if tgaalphav then 
			  begin
			    img.coltype:=rgba;
				setlength(img.pal.a,img.leni);
				bipca:=extrabits;
				img.maxa:=1 shl bipca-1;
			  end
			  else img.coltype:=rgb;
			  setlength(img.pal.r,img.leni);
			  setlength(img.pal.g,img.leni);
			  setlength(img.pal.b,img.leni);
			  img.maxr:=1 shl bipcrgb-1;
			  img.maxg:=1 shl bipcrgb-1;
			  img.maxb:=1 shl bipcrgb-1;
			  
			  for i:=0 to img.leni-1 do
			  begin
				img.pal.r[i]:=0;
				img.pal.g[i]:=0;
				img.pal.b[i]:=0;
			    if tgaalphav then img.pal.a[i]:=0;
			  end;
			  for i:=getpcword(tgahead.colmapspec_fei) to getpcword(tgahead.colmapspec_fei)+getpcword(tgahead.colmapspec_cml)-1 do
			  begin
				setpclongword(c,0);
				blockread(tgaf,c,(tgahead.colmapspec_cmes+7) div 8);
				tgacol.b:=getpclongword(c) and img.maxb;
				tgacol.g:=(getpclongword(c) shr bipcrgb) and img.maxg;
				tgacol.r:=(getpclongword(c) shr (2*bipcrgb)) and img.maxr;
				if tgaalphav then
				begin
				  tgacol.a:=(getpclongword(c) shr (3*bipcrgb)) and img.maxa;
				  img.pal.a[i]:=tgacol.a;
				end;
				if tgaalphav and (tgaalpha=4) and (tgacol.a>0) then
				begin
				  img.pal.b[i]:=mini(img.maxb,round(tgacol.b/tgacol.a));
				  img.pal.g[i]:=mini(img.maxg,round(tgacol.g/tgacol.a));
				  img.pal.r[i]:=mini(img.maxr,round(tgacol.r/tgacol.a));
				end
				else
				begin
				  img.pal.b[i]:=tgacol.b;
				  img.pal.g[i]:=tgacol.g;
				  img.pal.r[i]:=tgacol.r;
				end;
			  end;
            end;
      2,10: begin
              img.imgtype:=tru;
              bipcrgb:=(tgahead.imagespec_pd-extrabits) div 3;
              if tgaalphav then 
			  begin
			    img.coltype:=rgba;
				setlength(img.img.a,img.sy,img.sx);
				bipca:=extrabits;
				img.maxa:=1 shl bipca-1;
			  end
			  else img.coltype:=rgb;
			  setlength(img.img.r,img.sy,img.sx);
			  setlength(img.img.g,img.sy,img.sx);
			  setlength(img.img.b,img.sy,img.sx);
			  img.maxr:=1 shl bipcrgb-1;
			  img.maxg:=1 shl bipcrgb-1;
			  img.maxb:=1 shl bipcrgb-1;
            end;
      3,11: begin
              img.imgtype:=tru;
              bipcy:=tgahead.imagespec_pd-extrabits;
              if tgaalphav then
			  begin
			    img.coltype:=ya;
				setlength(img.img.a,img.sy,img.sx);
				bipca:=extrabits;
				img.maxa:=1 shl bipca-1;
			  end
			  else img.coltype:=y;
			  setlength(img.img.y,img.sy,img.sx);
			  img.maxy:=1 shl bipcy-1;
            end;
      end;

    getmem(tgad,img.sy*img.sx*bypp);
	case tgahead.imagetype of
    1,2,3: blockread(tgaf,tgad^,img.sy*img.sx*bypp);
    9,10,11: begin
        px:=0;
        py:=0;
        while py<img.sy do
        begin
          blockread(tgaf,b,1);
          if b and 128>0 then {RL}
          begin
			setpclongword(c,0);
			blockread(tgaf,c,bypp);
			for j:=0 to b and 127 do for k:=0 to bypp-1 do 
			    byte((tgad+py*img.sx*bypp+(px+j)*bypp+k)^):=byte((pointer(@c)+k)^);
		  end
          else
          begin
            blockread(tgaf,(tgad+py*img.sx*bypp+px*bypp)^,((b and 127)+1)*bypp);
          end;
          inc(px,(b and 127)+1);
          if px>=img.sx then
          begin
            px:=0;
            inc(py);
          end;
        end;
      end;
    end;

    {Bildumkehr??}
    flipx:=(tgahead.imagespec_id and 16>0);
    flipy:=(tgahead.imagespec_id and 32=0);
    for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
    begin
      case tgahead.imagetype of
      1,9:  begin
              setpclongword(c,0);
              for k:=0 to bypp-1 do byte((pointer(@c)+k)^):=byte((tgad+j*img.sx*bypp+i*bypp+k)^);
	          img.img.i[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=getpclongword(c);
			end;
      2,10: begin
              bipcrgb:=(tgahead.imagespec_pd-extrabits) div 3;
              setpclongword(c,0);
              for k:=0 to bypp-1 do byte((pointer(@c)+k)^):=byte((tgad+j*img.sx*bypp+i*bypp+k)^);
			  tgacol.b:=getpclongword(c) and img.maxb;
			  tgacol.g:=(getpclongword(c) shr bipcrgb) and img.maxg;
			  tgacol.r:=(getpclongword(c) shr (2*bipcrgb)) and img.maxr;
              if tgaalphav then
              begin
				tgacol.a:=(getpclongword(c) shr (3*bipcrgb)) and img.maxa;
				img.img.a[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=tgacol.a;
			  end;
			  if tgaalphav and (tgaalpha=4) and (tgacol.a>0) then
			  begin
				img.img.b[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=mini(img.maxb,round(tgacol.b/tgacol.a));
				img.img.g[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=mini(img.maxg,round(tgacol.g/tgacol.a));
				img.img.r[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=mini(img.maxr,round(tgacol.r/tgacol.a));
			  end
			  else
			  begin
				img.img.b[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=tgacol.b;
				img.img.g[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=tgacol.g;
				img.img.r[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=tgacol.r;
			  end;
            end;
      3,11: begin
              bipcy:=tgahead.imagespec_pd-extrabits;
              setpclongword(c,0);
              for k:=0 to bypp-1 do byte((pointer(@c)+k)^):=byte((tgad+j*img.sx*bypp+i*bypp+k)^);
			  tgacol.y:=getpclongword(c) and img.maxy;
              if tgaalphav then
              begin
				tgacol.a:=(getpclongword(c) shr bipcrgb) and img.maxa;
				img.img.a[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=tgacol.a;
              end;
			  if tgaalphav and (tgaalpha=4) and (tgacol.a>0) then
			  begin
				img.img.y[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=mini(img.maxy,round(tgacol.y/tgacol.a));
			  end
			  else
			  begin
				img.img.y[abs(j-(img.sy-1)*byte(flipy)),abs(i-(img.sx-1)*byte(flipx))]:=tgacol.y;
			  end;
            end;
      end;
    end;
    freemem(tgad,img.sy*img.sx*bypp);
    close(tgaf);
  end
  else writeln('tgaload: file '+tgas+' not found');
  tgaload:=img;
end;

function bmpload(bmps:string):timage;
type pcword=array[0..1] of byte;
     pclongword=array[0..3] of byte;
     trgb_win=record
       b,g,r,d:byte;
       end;
     trgb_os2=record
       b,g,r:byte;
       end;
     tbmpfhead=record
       identifier:array[0..1] of char;
       filesize:pclongword;
       reserved:pclongword;
       bitmapdataofset:pclongword;
       bitmapheadersize:pclongword;
       end;
     tbmpihead_win=record
       width:pclongword;
       height:pclongword;
       planes:pcword;
       bitsperpixel:pcword;
       compression:pclongword;
       bitmapdatasize:pclongword;
       hresolution:pclongword;
       vresolution:pclongword;
       colors:pclongword;
       importantcolors:pclongword;
     end;
     tbmpihead_os2=record
       width:pcword;
       height:pcword;
       planes:pcword;
       bitsperpixel:pcword;
     end;
     tbmpihead_uni=record
       width:longint;
       height:longint;
       bitsperpixel:word;
       compression:longint;
       colors:longint;
     end;
     tbmptype=(win,os2);
     tbmpbitfields=record
       red,green,blue:pclongword;
       end;
var bmpfhead:tbmpfhead;
    bmpihead_win:tbmpihead_win;
    bmpihead_os2:tbmpihead_os2;
    bmpihead_uni:tbmpihead_uni;
    bmptype:tbmptype;
    bmpcol_win:trgb_win;
    bmpcol_os2:trgb_os2;
    bypslbmp:longint;
    pixel:pclongword;
    bitfields:tbmpbitfields;
	bmpf:file;
    i,j:longint;
    bmpd:tbuf;
    shrr,shrg,shrb:byte;
    px,py:longint;
    b1,b2,b3,b4,bd:byte;
	img:timage;
function getpcword(a:pcword):word;
begin
  getpcword:=256*a[1]+a[0];
end;
function getpclongword(a:pclongword):longint;
begin
  getpclongword:=((a[3]*256+a[2])*256+a[1])*256+a[0];
end;
procedure setpcword(var a:pcword;w:word);
begin
  a[0]:=w mod 256;
  w:=(w-a[0]) div 256;
  a[1]:=w mod 256;
end;
procedure setpclongword(var a:pclongword; w:longword);
begin
  a[0]:=w mod 256;
  w:=(w-a[0]) div 256;
  a[1]:=w mod 256;
  w:=(w-a[1]) div 256;
  a[2]:=w mod 256;
  w:=(w-a[2]) div 256;
  a[3]:=w mod 256;
end;
begin  
  img:=resetimg;
  assign(bmpf,bmps);
  reset(bmpf,1);
  if ioresult=0 then
  begin
    blockread(bmpf,bmpfhead,sizeof(bmpfhead));

    case getpclongword(bmpfhead.bitmapheadersize) of
    $28: begin
           bmptype:=win;
           blockread(bmpf,bmpihead_win,sizeof(bmpihead_win));
           bmpihead_uni.width:=getpclongword(bmpihead_win.width);
           bmpihead_uni.height:=getpclongword(bmpihead_win.height);
           bmpihead_uni.bitsperpixel:=getpcword(bmpihead_win.bitsperpixel);
           bmpihead_uni.compression:=getpclongword(bmpihead_win.compression);
           if getpclongword(bmpihead_win.colors)>0 then bmpihead_uni.colors:=getpclongword(bmpihead_win.colors)
                                                   else bmpihead_uni.colors:=1 shl getpcword(bmpihead_win.bitsperpixel);
         end;
    $0c: begin
           bmptype:=os2;
           blockread(bmpf,bmpihead_os2,sizeof(bmpihead_os2));
           bmpihead_uni.width:=getpcword(bmpihead_os2.width);
           bmpihead_uni.height:=getpcword(bmpihead_os2.height);
           bmpihead_uni.bitsperpixel:=getpcword(bmpihead_os2.bitsperpixel);
           bmpihead_uni.compression:=0;
           bmpihead_uni.colors:=(getpclongword(bmpfhead.bitmapdataofset)-filepos(bmpf)) div 3;
         end;
    end;

    img.sx:=bmpihead_uni.width;
    img.sy:=abs(bmpihead_uni.height);

    img.coltype:=rgb;
    case bmpihead_uni.bitsperpixel of
    1,4,8: begin
         img.imgtype:=idx;
         bypslbmp:=4*((bmpihead_uni.bitsperpixel*img.sx+31) div 32);
		 img.leni:=1 shl bmpihead_uni.bitsperpixel;
		 setlength(img.img.i,img.sy,img.sx);
		 setlength(img.pal.r,img.leni);
		 setlength(img.pal.g,img.leni);
		 setlength(img.pal.b,img.leni);
		 img.maxr:=255;
		 img.maxg:=255;
		 img.maxb:=255;
       end;
    16,24,32: begin
         img.imgtype:=tru;
         bypslbmp:=4*((bmpihead_uni.bitsperpixel*img.sx+31) div 32);
		 setlength(img.img.r,img.sy,img.sx);
		 setlength(img.img.g,img.sy,img.sx);
		 setlength(img.img.b,img.sy,img.sx);
       end;
    end;

    if img.imgtype=idx then
    begin
      for i:=0 to bmpihead_uni.colors-1 do
      begin
        case bmptype of
        win: begin
               blockread(bmpf,bmpcol_win,sizeof(trgb_win));
               img.pal.r[i]:=bmpcol_win.r;
               img.pal.g[i]:=bmpcol_win.g;
               img.pal.b[i]:=bmpcol_win.b;
             end;
        os2: begin
               blockread(bmpf,bmpcol_os2,sizeof(trgb_os2));
               img.pal.r[i]:=bmpcol_os2.r;
               img.pal.g[i]:=bmpcol_os2.g;
               img.pal.b[i]:=bmpcol_os2.b;
             end;
        end;
      end;
      for i:=bmpihead_uni.colors to (1 shl bmpihead_uni.bitsperpixel)-1 do
      begin
        img.pal.r[i]:=0;
        img.pal.g[i]:=0;
        img.pal.b[i]:=0;
      end;
    end;
    if img.imgtype=tru then
    begin
      case bmpihead_uni.compression of
      0: begin
           case bmpihead_uni.bitsperpixel of
           16: begin
                 setpclongword(bitfields.red,$7c00);
                 setpclongword(bitfields.green,$03e0);
                 setpclongword(bitfields.blue,$001f);
               end;
           24,32: begin
                 setpclongword(bitfields.red,$00ff0000);
                 setpclongword(bitfields.green,$0000ff00);
                 setpclongword(bitfields.blue,$000000ff);
               end;
           end;
         end;
      3: blockread(bmpf,bitfields,sizeof(bitfields));
	  end;
	  img.maxr:=0;
	  img.maxg:=0;
	  img.maxb:=0;
      for i:=31 downto 0 do
      begin
        if (getpclongword(bitfields.red)   shr i) mod 2=1 then 
		begin
		  shrr:=i;
		  img.maxr:=2*img.maxr+1;
		end;
        if (getpclongword(bitfields.green) shr i) mod 2=1 then
		begin
		  shrg:=i;
		  img.maxg:=2*img.maxg+1;
		end;
        if (getpclongword(bitfields.blue)  shr i) mod 2=1 then
		begin
		  shrb:=i;
		  img.maxb:=2*img.maxb+1;
		end;
      end;
    end;
    seek(bmpf,getpclongword(bmpfhead.bitmapdataofset));

    if img.imgtype=idx then
    begin
      bmpd:=initbuf(img.sy*bypslbmp);
      case bmpihead_uni.compression of
      0: blockread(bmpf,bmpd.data^,img.sy*bypslbmp);
      1,2: begin
           py:=0;
           px:=0;
           repeat
             blockread(bmpf,b1,1);
             blockread(bmpf,b2,1);
             case b1 of
             0: case b2 of
                0: begin
                     inc(py);
                     px:=0;
                   end;
                1: ;
                2: begin
                     blockread(bmpf,b3,1);
                     blockread(bmpf,b4,1);
                     inc(px,b3 div bmpihead_uni.compression);
                     inc(py,b4 div bmpihead_uni.compression);
                   end;
                else
                  begin
                    blockread(bmpf,(bmpd.data+py*bypslbmp+px)^,b2 div bmpihead_uni.compression);
                    inc(px,b2 div bmpihead_uni.compression);
                    if (b2 div bmpihead_uni.compression) mod 2=1 then blockread(bmpf,bd,1);
                  end;
                end;
             else
               begin
                 for i:=0 to b1 div bmpihead_uni.compression-1 do byte((bmpd.data+py*bypslbmp+px+i)^):=b2;
                 inc(px,b1 div bmpihead_uni.compression);
               end;
             end;
           until (b1=0) and (b2=1);
         end;
      end;
    end
    else
    begin
      bmpd:=initbuf(3*img.sy*img.sx);
      for j:=0 to img.sy-1 do
      begin
        seek(bmpf,getpclongword(bmpfhead.bitmapdataofset)+j*bypslbmp);
        for i:=0 to img.sx-1 do
        begin
          setpclongword(pixel,0);
          blockread(bmpf,pixel,bmpihead_uni.bitsperpixel div 8);
          byte((bmpd.data+3*j*img.sx+3*i+0)^):=(getpclongword(pixel) and getpclongword(bitfields.red  )) shr shrr;
          byte((bmpd.data+3*j*img.sx+3*i+1)^):=(getpclongword(pixel) and getpclongword(bitfields.green)) shr shrg;
          byte((bmpd.data+3*j*img.sx+3*i+2)^):=(getpclongword(pixel) and getpclongword(bitfields.blue )) shr shrb;
        end;
      end;
    end;

    if bmpihead_uni.height<0 then
	begin
      for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
	  case img.imgtype of
	  idx: img.img.i[j,i]:=readbuf(bmpd,8*j*bypslbmp+i*bmpihead_uni.bitsperpixel,bmpihead_uni.bitsperpixel);
	  tru: begin
	         img.img.r[j,i]:=byte((bmpd.data+3*j*img.sx+3*i)^);
	         img.img.g[j,i]:=byte((bmpd.data+3*j*img.sx+3*i+1)^);
	         img.img.b[j,i]:=byte((bmpd.data+3*j*img.sx+3*i+2)^);
		   end;
	  end;
	end
    else
	begin
      for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do
	  case img.imgtype of
	  idx: img.img.i[j,i]:=readbuf(bmpd,8*(img.sy-j-1)*bypslbmp+i*bmpihead_uni.bitsperpixel,bmpihead_uni.bitsperpixel);
	  tru: begin
	         img.img.r[j,i]:=byte((bmpd.data+3*(img.sy-j-1)*img.sx+3*i)^);
	         img.img.g[j,i]:=byte((bmpd.data+3*(img.sy-j-1)*img.sx+3*i+1)^);
	         img.img.b[j,i]:=byte((bmpd.data+3*(img.sy-j-1)*img.sx+3*i+2)^);
		   end;
	  end;
	end;
    donebuf(bmpd);
    close(bmpf);
  end
  else writeln('bmpload: file '+bmps+' not found');
  bmpload:=img;
end;

end.
