unit n2_transforms;

interface

uses n2_matrix,n2_vector;

function ft(v:tvector):tvectorc;
function ft(v:tvectorc):tvectorc;
function ft(m:tmatrix):tmatrixc;
function ft(m:tmatrixc):tmatrixc;
function ift(v:tvector):tvectorc;
function ift(v:tvectorc):tvectorc;
function ift(m:tmatrix):tmatrixc;
function ift(m:tmatrixc):tmatrixc;

function ht_at(v:tvector):tvectorc;
function ht_at(v:tvectorc):tvectorc;
function ht_af(v:tvector):tvectorc;
function ht_af(v:tvectorc):tvectorc;
function ht_rt(v:tvector):tvector;
function ht_rt(v:tvectorc):tvectorc;
function ht_rf(v:tvector):tvectorc;
function ht_rf(v:tvectorc):tvectorc;
function ht(v:tvector):tvector;
function ht(v:tvectorc):tvectorc;
function iht(v:tvector):tvector;
function iht(v:tvectorc):tvectorc;


implementation

uses n2_mathe,n2_complex;

function fftn(v:tvectorc;pp:longint;vm:tvectorc):tvectorc;
var n,p,q,i,j,k:longint;
	f:boolean;
	vo:tvectorc;
	vi:array of tvectorc;
begin
  n:=length(v);
  vo:=initvc(n);
  if n=1 then vo[0]:=v[0]
  else
  begin
    p:=2;
    f:=false;
    while not f do
	begin
	  if n mod p=0 then
	  begin
	    q:=n div p;
		setlength(vi,p);
		for j:=0 to p-1 do 
		begin
		  vi[j]:=initvc(q);
		  for i:=0 to q-1 do vi[j,i]:=v[i*p+j];
		  vi[j]:=fftn(vi[j],p,vm);
		end;
		for k:=0 to n-1 do vo[k]:=addc(vo[k],vi[0,k mod q]);
		for k:=0 to n-1 do for j:=1 to p-1 do vo[k]:=addc(vo[k],mulc(vm[(pp*(j*k)) mod n],vi[j,k mod q]));
		f:=true;
	  end
	  else inc(p);
	end;
  end;
  fftn:=vo;
end;

procedure conv(var ca,cb:tcomplex;ce:tcomplex);
var
  cv,ch:tcomplex;
begin
  ch:=mulc(0.5,mulc(ce,cb));
  cv:=mulc(0.5,ca);
  ca:=addc(cv,ch);
  cb:=subc(cv,ch);
end;

function exchw(i,s:longint):longint;
var
  r,o:longint;
begin
  o:=0;
  for r:=0 to s-2 do
  begin
    inc(o,i and 1);
    i:=i shr 1;
    o:=o shl 1;
  end;
  inc(o,i and 1);
  exchw:=o;
end;

procedure umsort(var v:tvectorc;s:longint);
var
  r,ri:longint;
  c:tcomplex;
begin
  for r:=0 to round(exp(s*ln(2)))-1 do
  begin
    ri:=exchw(r,s);
    if ri>r then
    begin
      c:=v[r];
      v[r]:=v[ri];
      v[ri]:=c;
    end;
  end;
end;

procedure fft2(var v:tvectorc);
var
  shft,r,q,p,j,k,s:longint;
  ce:tcomplex;
begin
  s:=round(ln(length(v))/ln(2));
  for r:=s downto 1 do
  begin
	q:=round(exp((r-1)*ln(2)));
	p:=round(exp((s-r)*ln(2)));
	for j:=0 to p-1 do
	begin
	  shft:=exchw(j,s-r+1)*q;
	  ce:=expc(setc(0,-j*pi/p));
	  for k:=0 to q-1 do conv(v[k+shft],v[k+shft+q],ce);
	end;
  end;
  umsort(v,s);
  for r:=0 to length(v)-1 do v[r]:=mulc(length(v),v[r]);
end;

procedure ifft2(var v:tvectorc);
var
  shft,r,q,p,j,k,s:longint;
  ce:tcomplex;
begin
  s:=round(ln(length(v))/ln(2));
  for r:=s downto 1 do
  begin
	q:=round(exp((r-1)*ln(2)));
	p:=round(exp((s-r)*ln(2)));
	for j:=0 to p-1 do
	begin
	  shft:=exchw(j,s-r+1)*q;
	  ce:=expc(setc(0,+j*pi/p));
	  for k:=0 to q-1 do conv(v[k+shft],v[k+shft+q],ce);
	end;
  end;
  umsort(v,s);
end;

procedure fftk(x:tvectorc;n,m:longint;w:tvectorc);
var ni,t,i,j,k:longint;
    a,y:tvectorc;
begin
  if n>1 then
  begin
    ni:=2;
    while n mod ni>0 do inc(ni);
    t:=n div ni;
    y:=initvc(n);
    a:=initvc(t);
    for i:=0 to n-1 do y[i]:=setc(0,0);
    for j:=0 to ni-1 do
    begin
      for i:=0 to t-1 do a[i]:=x[i*ni+j];
      fftk(a,t,ni*m,w);
      for k:=0 to ni-1 do for i:=0 to t-1 do y[i+k*t]:=addc(y[i+k*t],mulc(w[((j*(i+t*k)) mod n)*m],a[i]))
    end;
    for i:=0 to n-1 do x[i]:=y[i];
  end;
end;

procedure ft1(var v:tvectorc);
var i:longint;
	w:tvectorc;
begin
  i:=round(ln(length(v))/ln(2));
  i:=round(exp(i*ln(2)));
  if i=length(v) then fft2(v)
  else
  begin
    w:=initvc(length(v));
    for i:=0 to length(w)-1 do w[i]:=setc(cos(-2*pi*i/length(v)),sin(-2*pi*i/length(v)));
    fftk(v,length(v),1,w);
//	fftn(v,1,w);
  end;
end;

procedure ift1(var v:tvectorc);
var i:longint;
	w:tvectorc;
begin
  i:=round(ln(length(v))/ln(2));
  i:=round(exp(i*ln(2)));
  if i=length(v) then ifft2(v)
  else
  begin
    w:=initvc(length(v));
    for i:=0 to length(w)-1 do w[i]:=setc(cos(+2*pi*i/length(v)),sin(+2*pi*i/length(v)));
    fftk(v,length(v),1,w);
//	fftn(v,1,w);
    for i:=0 to length(v)-1 do v[i]:=mulc(1/length(v),v[i]);
  end;
end;

function ft(v:tvector):tvectorc;
var i:longint;
	f:tvectorc;
begin
  f:=initvc(length(v));
  for i:=0 to length(f)-1 do f[i]:=setc(v[i],0);
  ft1(f);
  ft:=f;
end;

function ft(v:tvectorc):tvectorc;
var i:longint;
	f:tvectorc;
begin
  f:=initvc(length(v));
  for i:=0 to length(f)-1 do f[i]:=v[i];
  ft1(f);
  ft:=f;
end;

function ft(m:tmatrix):tmatrixc;
var i,j:longint;
    mi:tmatrixc;
	f:tvectorc;
begin
  mi:=initmc(length(m),length(m[0]));
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=setc(m[j,i],0);
  if length(mi[0])>1 then
  begin
    f:=initvc(length(mi[0]));
    for j:=0 to length(mi)-1 do
    begin
      for i:=0 to length(mi[0])-1 do f[i]:=mi[j,i];
      ft1(f);
      for i:=0 to length(mi[0])-1 do mi[j,i]:=f[i];
    end;
  end;
  if length(mi)>1 then 
  begin
    f:=initvc(length(mi));
    for i:=0 to length(mi[0])-1 do
    begin
      for j:=0 to length(mi)-1 do f[j]:=mi[j,i];
      ft1(f);
      for j:=0 to length(mi)-1 do mi[j,i]:=f[j];
	end;
  end;
  ft:=mi;
end;

function ft(m:tmatrixc):tmatrixc;
var i,j:longint;
    mi:tmatrixc;
	f:tvectorc;
begin
  mi:=initmc(length(m),length(m[0]));
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
  if length(mi[0])>1 then
  begin
    f:=initvc(length(mi[0]));
    for j:=0 to length(mi)-1 do
    begin
      for i:=0 to length(mi[0])-1 do f[i]:=mi[j,i];
      ft1(f);
      for i:=0 to length(mi[0])-1 do mi[j,i]:=f[i];
    end;
  end;
  if length(mi)>1 then 
  begin
    f:=initvc(length(mi));
    for i:=0 to length(mi[0])-1 do
    begin
      for j:=0 to length(mi)-1 do f[j]:=mi[j,i];
      ft1(f);
      for j:=0 to length(mi)-1 do mi[j,i]:=f[j];
	end;
  end;
  ft:=mi;
end;

function ift(v:tvector):tvectorc;
var i:longint;
	f:tvectorc;
begin
  f:=initvc(length(v));
  for i:=0 to length(f)-1 do f[i]:=setc(v[i],0);
  ift1(f);
  ift:=f;
end;

function ift(v:tvectorc):tvectorc;
var i:longint;
	f:tvectorc;
begin
  f:=initvc(length(v));
  for i:=0 to length(f)-1 do f[i]:=v[i];
  ift1(f);
  ift:=f;
end;

function ift(m:tmatrix):tmatrixc;
var i,j:longint;
    mi:tmatrixc;
    f:tvectorc;
begin
  mi:=initmc(length(m),length(m[0]));
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=setc(m[j,i],0);
  if length(mi[0])>1 then
  begin
    f:=initvc(length(mi[0]));
    for j:=0 to length(mi)-1 do
    begin
      for i:=0 to length(mi[0])-1 do f[i]:=mi[j,i];
      ift1(f);
      for i:=0 to length(mi[0])-1 do mi[j,i]:=f[i];
    end;
  end;
  if length(mi)>1 then 
  begin
    f:=initvc(length(mi));
    for i:=0 to length(mi[0])-1 do
    begin
      for j:=0 to length(mi)-1 do f[j]:=mi[j,i];
      ift1(f);
      for j:=0 to length(mi)-1 do mi[j,i]:=f[j];
	end;
  end;
  ift:=mi;
end;

function ift(m:tmatrixc):tmatrixc;
var i,j:longint;
    mi:tmatrixc;
	f:tvectorc;
begin
  mi:=initmc(length(m),length(m[0]));
  for j:=0 to length(mi)-1 do for i:=0 to length(mi[0])-1 do mi[j,i]:=m[j,i];
  if length(mi[0])>1 then
  begin
    f:=initvc(length(mi[0]));
    for j:=0 to length(mi)-1 do
    begin
      for i:=0 to length(mi[0])-1 do f[i]:=mi[j,i];
      ift1(f);
      for i:=0 to length(mi[0])-1 do mi[j,i]:=f[i];
    end;
  end;
  if length(mi)>1 then 
  begin
    f:=initvc(length(mi));
    for i:=0 to length(mi[0])-1 do
    begin
      for j:=0 to length(mi)-1 do f[j]:=mi[j,i];
      ift1(f);
      for j:=0 to length(mi)-1 do mi[j,i]:=f[j];
	end;
  end;
  ift:=mi;
end;

function ht_at(v:tvector):tvectorc;
var vi:tvectorc;
    i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=mulc(2,vi[i]) else vi[i]:=setc(0,0);
  ht_at:=ift(vi);
end;

function ht_at(v:tvectorc):tvectorc;
var vi:tvectorc;
    i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=mulc(2,vi[i]) else vi[i]:=setc(0,0);
  ht_at:=ift(vi);
end;

function ht_af(v:tvector):tvectorc;
var vi:tvectorc;
    i:longint;
begin
  vi:=initvc(length(v));
  for i:=0 to length(vi) do vi[i]:=setc(v[i],0);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=mulc(2,vi[i]) else vi[i]:=setc(0,0);
  ht_af:=vi;
end;

function ht_af(v:tvectorc):tvectorc;
var vi:tvectorc;
    i:longint;
begin
  vi:=initvc(length(v));
  for i:=0 to length(vi) do vi[i]:=v[i];
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=mulc(2,vi[i]) else vi[i]:=setc(0,0);
  ht_af:=vi;
end;

function ht_rt(v:tvector):tvector;
var vi:tvectorc;
    vo:tvector;
	i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(vi[i].im,-vi[i].re) else vi[i]:=setc(-vi[i].im,vi[i].re);
  vi:=ift(vi);
  vo:=initv(length(vi));
  for i:=0 to length(vo) do vo[i]:=vi[i].re;
  ht_rt:=vo;
end;

function ht_rt(v:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(vi[i].im,-vi[i].re) else vi[i]:=setc(-vi[i].im,vi[i].re);
  ht_rt:=ift(vi);
end;

function ht_rf(v:tvector):tvectorc;
var vi:tvectorc;
    i:longint;
begin
  vi:=initvc(length(v));
  for i:=0 to length(vi) do vi[i]:=setc(v[i],0);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(vi[i].im,-vi[i].re) else vi[i]:=setc(-vi[i].im,vi[i].re);
  ht_rf:=vi;
end;

function ht_rf(v:tvectorc):tvectorc;
var vi:tvectorc;
    i:longint;
begin
  vi:=initvc(length(v));
  for i:=0 to length(vi) do vi[i]:=v[i];
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(vi[i].im,-vi[i].re) else vi[i]:=setc(-vi[i].im,vi[i].re);
  ht_rf:=vi;
end;


function ht(v:tvector):tvector;
var vi:tvectorc;
    vo:tvector;
	i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(vi[i].im,-vi[i].re) else vi[i]:=setc(-vi[i].im,vi[i].re);
  vi:=ift(vi);
  vo:=initv(length(vi));
  for i:=0 to length(vo) do vo[i]:=vi[i].re;
  ht:=vo;
end;

function ht(v:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(vi[i].im,-vi[i].re) else vi[i]:=setc(-vi[i].im,vi[i].re);
  ht:=ift(vi);
end;

function iht(v:tvector):tvector;
var vi:tvectorc;
    vo:tvector;
	i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(-vi[i].im,vi[i].re) else vi[i]:=setc(vi[i].im,-vi[i].re);
  vi:=ift(vi);
  vo:=initv(length(vi));
  for i:=0 to length(vo) do vo[i]:=vi[i].re;
  iht:=vo;
end;

function iht(v:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=ft(v);
  for i:=0 to length(vi) do if 2*i<length(vi) then vi[i]:=setc(-vi[i].im,vi[i].re) else vi[i]:=setc(vi[i].im,-vi[i].re);
  iht:=ift(vi);
end;


end.
