unit random;

interface

const r60=0;
const r70=1;
const r80=2;
const rx=3;

function random60:double;
function random70:double;
function random80:double;
function gleichran:double;
function gaussran:double;
function expran:double;
function poissonran(lam:double):longint;
procedure setrandom(fw:byte);

implementation

uses n2_mathe;

var sw:byte;

procedure setrandom(fw:byte);
begin
  sw:=fw;
end;

function random60:double;
type tla=array[0..1] of longint;
var r:comp;
begin
  tla(addr(r)^)[1]:=0;
  tla(addr(r)^)[0]:=randseed;
  r:=r*134775813+1;
  randseed:=tla(addr(r)^)[0];
  random60:=abs(randseed/2147483648.0);
end;

function random70:double;
type tla=array[0..1] of longint;
var r:comp;
begin
  tla(addr(r)^)[1]:=0;
  tla(addr(r)^)[0]:=randseed;
  r:=r*134775813+1;
  randseed:=tla(addr(r)^)[0];
  random70:=randseed/4294967296.0+0.5;
end;

function random80:double;
type tba=array[0..3] of byte;
type twa=array[0..3] of word;
const mm:longint=134775813;
var rsa,mma,ppa:twa;
    xma,xca:array[0..3] of twa;
    xcc:word;
    i,j:byte;
procedure split(l:cardinal;var wa:twa);
var i:byte;
begin
  for i:=0 to 3 do wa[i]:=tba(l)[i];
end;
procedure glue(wa:twa; var l:cardinal);
var i:byte;
begin
  for i:=0 to 3 do if wa[i]>255 then
  begin
    writeln('overflow');
    halt;
  end else tba(l)[i]:=wa[i];
end;
procedure mult(w1,w2:word;var c,m:word);
begin
  c:=(w1*w2) div 256;
  m:=(w1*w2) mod 256;
end;
procedure addc(w1,w2,co:word;var c,m:word);
begin
  c:=(w1+w2+co) div 256;
  m:=(w1+w2+co) mod 256;
end;
begin
  split(randseed,rsa);
  split(mm,mma);
  for i:=0 to 3 do for j:=0 to 3-i do mult(rsa[i],mma[j],xca[i,j],xma[i,j]);
  for i:=0 to 3 do ppa[i]:=0;
  for i:=0 to 3 do
  begin
    xcc:=byte(i=0);
    for j:=0 to 3-i do addc(ppa[i+j],xma[i,j],xcc,xcc,ppa[i+j]);
    xcc:=0;
    for j:=1 to 3-i do addc(ppa[i+j],xca[i,j-1],xcc,xcc,ppa[i+j]);
  end;
  glue(ppa,randseed);
  random80:=frac(randseed/4294967296.0+0.5);
end;

function gleichran:double;
begin
  case sw of
  r60: gleichran:=random60;
  r70: gleichran:=random70;
  r80: gleichran:=random80;
  rx:  gleichran:=system.random;
  end;
end;

function gaussran:double;
begin
  gaussran:=sqrt(-2*ln(1-gleichran))*cos(2*pi*gleichran);
end;

function expran:double;
begin
  expran:=-ln(1-gleichran);
end;

{
function poissonran(lam:double):longint;
var s:double;
    n:longint;
    e:double;
begin
  s:=1;
  n:=0;
  e:=exp(-lam);
  if e>0 then
  begin
    while s>=e do
    begin
      s:=s*(1-gleichran);
      inc(n);
    end;
    poissonran:=n-1;
  end
  else poissonran:=maxi(0,round(lam+sqrt(lam)*gaussran));
end;
}

function poissonran(lam:double):longint;
var a,b,c:double;
    n:longint;
begin
  if lam<100 then
  begin
    a:=gleichran;
    n:=0;
    b:=exp(-lam);
    c:=b;
    while c<=a do
    begin
	  inc(n);
	  b:=b*lam/n;
      c:=c+b;
    end;
  end
  else n:=round(lam+sqrt(lam)*gaussran);
  poissonran:=n;
end;

begin
  setrandom(rx);
end.
